/******************************************************************************/
/***          Generated by IBExpert 2011.02.17                              ***/
/******************************************************************************/

SET SQL DIALECT 3;

SET NAMES WIN1251;

CREATE DATABASE ''
USER 'SYSDBA' PASSWORD 'masterkey'
PAGE_SIZE 1024
DEFAULT CHARACTER SET WIN1251;



/******************************************************************************/
/***                                Domains                                 ***/
/******************************************************************************/

CREATE DOMAIN "CardNo" AS
VARCHAR(20);

CREATE DOMAIN "CardOperation" AS
SMALLINT;

CREATE DOMAIN "CardType" AS
SMALLINT;

CREATE DOMAIN "Density" AS
NUMERIC(4,4);

CREATE DOMAIN "FuelVolume" AS
NUMERIC(7,2);

CREATE DOMAIN "Key" AS
INTEGER;

CREATE DOMAIN "LimitType" AS
SMALLINT;

CREATE DOMAIN "PumpCounter" AS
NUMERIC(9,2);

CREATE DOMAIN "TBoolean" AS
SMALLINT
NOT NULL
CHECK (value between 0 and 1);

CREATE DOMAIN "TankLevel" AS
NUMERIC(5,1);

CREATE DOMAIN "TankVolume" AS
NUMERIC(6,2);

CREATE DOMAIN "Temperature" AS
NUMERIC(3,1);



/******************************************************************************/
/***                               Generators                               ***/
/******************************************************************************/

CREATE GENERATOR FIB$FIELD_INFO_VERSION;
SET GENERATOR FIB$FIELD_INFO_VERSION TO 22;

CREATE GENERATOR "GEN_AutoNumber";
SET GENERATOR "GEN_AutoNumber" TO 0;

CREATE GENERATOR "GEN_Card_Id";
SET GENERATOR "GEN_Card_Id" TO 0;

CREATE GENERATOR "GEN_Card_Version";
SET GENERATOR "GEN_Card_Version" TO 0;

CREATE GENERATOR "GEN_Doc_Id";
SET GENERATOR "GEN_Doc_Id" TO 0;

CREATE GENERATOR "GEN_FuelOper_Id";
SET GENERATOR "GEN_FuelOper_Id" TO 0;

CREATE GENERATOR "GEN_Id";
SET GENERATOR "GEN_Id" TO 0;

CREATE GENERATOR "GEN_Limit_Id";
SET GENERATOR "GEN_Limit_Id" TO 0;

CREATE GENERATOR "GEN_TankState_Id";
SET GENERATOR "GEN_TankState_Id" TO 0;

CREATE GENERATOR "GEN_TransId";
SET GENERATOR "GEN_TransId" TO 0;



/******************************************************************************/
/***                               Exceptions                               ***/
/******************************************************************************/

CREATE EXCEPTION "cardNoChgErr" '     ';

CREATE EXCEPTION "dateInFuture" '  ';

CREATE EXCEPTION "nozzleNotActive" '       ';

CREATE EXCEPTION "pumpChgErr" '    -  ';

CREATE EXCEPTION "pumpTankIdErr" '        ';

CREATE EXCEPTION "tankAzsIdErr" '     -  ';

CREATE EXCEPTION "tankTerminalIdErr" '       ,   ';

CREATE EXCEPTION "terminalChgErr" '    -  ';

CREATE EXCEPTION "terminalSNchangeErr" '    -  ';

CREATE EXCEPTION "terminalTransactionExists" '      ';

CREATE EXCEPTION "terminalTransactionFailDate" '  ';



SET TERM ^ ; 



/******************************************************************************/
/***                           Stored Procedures                            ***/
/******************************************************************************/

CREATE PROCEDURE "Auto_DEL" (
    "AutoId" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Auto_IU" (
    "AutoId" INTEGER,
    "Pin" VARCHAR(6),
    "Number" VARCHAR(10),
    "Description" VARCHAR(255))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Azs_DEL" (
    "AzsId" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Azs_IU" (
    "AzsId" INTEGER,
    "Name" VARCHAR(30),
    "Owner" VARCHAR(30))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "BookTankStateByDate" (
    "TankId" INTEGER,
    "FuelId" INTEGER,
    "Date" TIMESTAMP)
RETURNS (
    "TankStateId" INTEGER)
AS
BEGIN
  SUSPEND;
END^





CREATE PROCEDURE "db_clear" (
    "ToDate" DATE)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "db_make_book_state"
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "EnableCardOnTerminal" (
    "CardId" INTEGER,
    "TerminalId" INTEGER,
    "Enabled" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "ExistsCardLimitForTerminal" (
    "cardId" INTEGER,
    "terminalId" INTEGER)
RETURNS (
    "exists" INTEGER)
AS
BEGIN
  SUSPEND;
END^





CREATE PROCEDURE "Fuel_DEL" (
    "FuelId" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Fuel_IU" (
    "FuelId" INTEGER,
    "FuelNo" INTEGER,
    "FuelName" VARCHAR(20),
    "Price" NUMERIC(7,2))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "FuelIncome_DEL" (
    "Id" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "FuelIncome_IU" (
    "Id" INTEGER,
    "OrgId" INTEGER,
    "TankId" INTEGER,
    "Date" TIMESTAMP,
    "Doc" VARCHAR(30),
    "DocDate" DATE,
    "Supplier" VARCHAR(30),
    "Volume" NUMERIC(7,2))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "FuelPriceByOrg_U" (
    "OrgId" INTEGER,
    "FuelId" INTEGER,
    "Price" NUMERIC(7,2))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "FuelSale_DEL" (
    "Id" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "FuelSale_IU" (
    "Id" INTEGER,
    "AzsId" INTEGER,
    "TankId" INTEGER,
    "OrgId" INTEGER,
    "Date" TIMESTAMP,
    "Doc" VARCHAR(30),
    "DocDate" DATE,
    "Client" VARCHAR(30),
    "AutoId" INTEGER,
    "FuelId" INTEGER,
    "Price" NUMERIC(7,2),
    "Volume" NUMERIC(7,2))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "FuelStorage_Add" (
    "OrgId" INTEGER,
    "FuelId" INTEGER,
    "Volume" NUMERIC(8,2))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "FuelStorage_Inv" (
    "OrgId" INTEGER,
    "FuelId" INTEGER,
    "Volume" NUMERIC(8,2),
    "Description" VARCHAR(255))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "FuelStorage_Move" (
    "OrgFromId" INTEGER,
    "OrgToId" INTEGER,
    "FuelId" INTEGER,
    "Volume" NUMERIC(8,2),
    "Description" VARCHAR(255))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "FuelStorage_U" (
    "OrgId" INTEGER,
    "FuelId" INTEGER,
    "Volume" NUMERIC(8,2))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Pump_DEL" (
    "PumpId" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Pump_IU" (
    "PumpId" INTEGER,
    "TerminalId" INTEGER,
    "PumpNo" INTEGER,
    "NozzleNo" INTEGER,
    "TankId" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Pump_setCounter" (
    "PumpId" INTEGER,
    "Date" TIMESTAMP,
    "Counter" NUMERIC(9,2),
    "Volume" NUMERIC(7,2))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Tank_DEL" (
    "TankId" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Tank_IU" (
    "TankId" INTEGER,
    "TankNo" SMALLINT,
    "AzsId" INTEGER,
    "TerminalId" INTEGER,
    "FuelId" INTEGER,
    "TotalHeight" INTEGER,
    "TotalVolume" INTEGER,
    "MinLevel" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Tank_l2mm" (
    "TankId" INTEGER,
    "Volume" NUMERIC(6,2))
RETURNS (
    "Level" NUMERIC(5,1))
AS
BEGIN
  SUSPEND;
END^





CREATE PROCEDURE "Tank_mm2l" (
    "TankId" INTEGER,
    "Level" NUMERIC(5,1))
RETURNS (
    "Volume" NUMERIC(6,2))
AS
BEGIN
  SUSPEND;
END^





CREATE PROCEDURE "TankBookState_U" (
    "TankId" INTEGER,
    "FuelId" INTEGER,
    "Date" TIMESTAMP,
    "DVolume" NUMERIC(7,2))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "TankCalibration_DEL" (
    "TankId" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "TankCalibration_INS" (
    "TankId" INTEGER,
    "Level" NUMERIC(5,1),
    "Volume" NUMERIC(6,2))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "TankRealState_INS" (
    "TankId" INTEGER,
    "Date" TIMESTAMP,
    "Status" INTEGER,
    "Level" NUMERIC(5,1),
    "Volume" NUMERIC(6,2),
    "Temperature" NUMERIC(3,1),
    "Density" NUMERIC(4,4),
    "WaterLevel" NUMERIC(5,1),
    "WaterVolume" NUMERIC(6,2))
RETURNS (
    "TankStateId" INTEGER)
AS
BEGIN
  SUSPEND;
END^





CREATE PROCEDURE "TankRealState_U" (
    "TankId" INTEGER,
    "Date" TIMESTAMP,
    "Status" INTEGER,
    "Level" NUMERIC(5,1),
    "Volume" NUMERIC(6,2),
    "Temperature" NUMERIC(3,1),
    "Density" NUMERIC(4,4),
    "WaterLevel" NUMERIC(5,1),
    "WaterVolume" NUMERIC(6,2),
    "Locked" SMALLINT)
RETURNS (
    "TankStateId" INTEGER)
AS
BEGIN
  SUSPEND;
END^





CREATE PROCEDURE "TankState_COPY" (
    "SrcTankStateId" INTEGER)
RETURNS (
    "DstTankStateId" INTEGER)
AS
BEGIN
  SUSPEND;
END^





CREATE PROCEDURE "TankState_INS" (
    "TankId" INTEGER,
    "Status" INTEGER,
    "Level" NUMERIC(5,1),
    "Volume" NUMERIC(6,2),
    "Temperature" NUMERIC(3,1),
    "Density" NUMERIC(4,4),
    "WaterLevel" NUMERIC(5,1),
    "WaterVolume" NUMERIC(6,2))
RETURNS (
    "TankStateId" INTEGER)
AS
BEGIN
  SUSPEND;
END^





CREATE PROCEDURE "TankStateHistoryByDate" (
    "Date" TIMESTAMP,
    "Compare" SMALLINT,
    "HistoryTableType" VARCHAR(10))
RETURNS (
    "TankId" INTEGER,
    "TankStateDate" TIMESTAMP,
    "TankStateId" INTEGER)
AS
BEGIN
  SUSPEND;
END^





CREATE PROCEDURE "Terminal_Add_TankState" (
    "TerminalId" INTEGER,
    "TankNo" INTEGER,
    "Date" TIMESTAMP,
    "Status" INTEGER,
    "Level" NUMERIC(5,1),
    "Volume" NUMERIC(6,2),
    "Temperature" NUMERIC(3,1),
    "Density" NUMERIC(4,4),
    "WaterLevel" NUMERIC(5,1),
    "Locked" SMALLINT)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Terminal_Add_Transaction" (
    "TerminalId" INTEGER,
    "TerminalTransNo" INTEGER,
    "CardNo" VARCHAR(20),
    "PumpId" INTEGER,
    "TankId" INTEGER,
    "FuelId" INTEGER,
    "OperId" INTEGER,
    "Volume" NUMERIC(7,2),
    "AutoType" INTEGER,
    "Auto" VARCHAR(20),
    "CurLimit" NUMERIC(7,2),
    "CurRest" NUMERIC(7,2),
    "DateBegin" TIMESTAMP,
    "DateEnd" TIMESTAMP,
    "CounterBegin" NUMERIC(15,2),
    "CounterEnd" NUMERIC(15,2),
    "TankStatusBegin" INTEGER,
    "LevelBegin" NUMERIC(5,1),
    "VolumeBegin" NUMERIC(6,2),
    "TemperatureBegin" NUMERIC(3,1),
    "DensityBegin" NUMERIC(4,4),
    "WaterLevelBegin" NUMERIC(5,1),
    "TankStatusEnd" INTEGER,
    "LevelEnd" NUMERIC(5,1),
    "VolumeEnd" NUMERIC(6,2),
    "TemperatureEnd" NUMERIC(3,1),
    "DensityEnd" NUMERIC(4,4),
    "WaterLevelEnd" NUMERIC(5,1))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "Terminal_SyncComplete" (
    "termId" INTEGER,
    "ok" INTEGER,
    "msg" VARCHAR(255))
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "User_DEL" (
    "UserId" INTEGER)
AS
BEGIN
  EXIT;
END^





CREATE PROCEDURE "User_IU" (
    "UserId" INTEGER,
    "Active" SMALLINT,
    "Name" VARCHAR(20),
    "Psw" VARCHAR(20),
    "Permissions" INTEGER)
AS
BEGIN
  EXIT;
END^






SET TERM ; ^



/******************************************************************************/
/***                                 Tables                                 ***/
/******************************************************************************/



CREATE TABLE "Auto" (
    "AutoId"       "Key" NOT NULL,
    "Pin"          VARCHAR(6),
    "Number"       VARCHAR(10) NOT NULL,
    "Description"  VARCHAR(255)
);


CREATE TABLE "Azs" (
    "AzsId"  "Key" NOT NULL,
    "Name"   VARCHAR(30),
    "Owner"  VARCHAR(30)
);


CREATE TABLE "Card" (
    "CardId"       INTEGER NOT NULL,
    "CardNo"       VARCHAR(20),
    "Owner"        VARCHAR(30),
    "OrgId"        "Key" NOT NULL,
    "Pin"          VARCHAR(4),
    "Type"         SMALLINT,
    "Enabled"      "TBoolean",
    "Expire"       DATE NOT NULL,
    "Description"  VARCHAR(50),
    "OperId"       "Key" NOT NULL,
    "Version"      INTEGER NOT NULL,
    "LastUpdate"   TIMESTAMP DEFAULT current_timestamp NOT NULL
);


CREATE TABLE "CardLimits" (
    "LimitId"       "Key" NOT NULL,
    "CardId"        "Key" NOT NULL,
    "LimitTypeId"   "Key" NOT NULL,
    "FromDate"      DATE NOT NULL,
    "ToDate"        DATE NOT NULL,
    "FuelId"        "Key" NOT NULL,
    "OrderVolume"   "FuelVolume" NOT NULL,
    "LastSaleDate"  TIMESTAMP NOT NULL
);


CREATE TABLE "CardLimitTypes" (
    "LimitTypeId"  "Key" NOT NULL,
    "Name"         VARCHAR(30) NOT NULL,
    "Enabled"      "TBoolean"
);


CREATE TABLE "CardOperationTypes" (
    "OperId"   "Key" NOT NULL,
    "Name"     VARCHAR(30),
    "Enabled"  "TBoolean"
);


CREATE TABLE "CardTerminals" (
    "CardId"      "Key" NOT NULL,
    "TerminalId"  "Key" NOT NULL
);


CREATE TABLE "CardTransaction" (
    "TransId"           "Key" NOT NULL,
    "CardId"            "Key" NOT NULL,
    "LimitType"         "LimitType",
    "OrgId"             "Key" NOT NULL,
    "AzsId"             "Key" NOT NULL,
    "TerminalId"        "Key" NOT NULL,
    "TerminalTransNo"   INTEGER,
    "PumpId"            "Key" NOT NULL,
    "FuelId"            "Key" NOT NULL,
    "TankId"            "Key",
    "OperId"            "Key" NOT NULL,
    "DateBegin"         TIMESTAMP NOT NULL,
    "DateEnd"           TIMESTAMP NOT NULL,
    "Date"              COMPUTED BY ("DateBegin"),
    "CounterBegin"      "PumpCounter",
    "CounterEnd"        "PumpCounter",
    "TankStateIdBegin"  "Key",
    "TankStateIdEnd"    "Key",
    "Volume"            "FuelVolume" NOT NULL,
    "Price"             NUMERIC(7,2),
    "Money"             NUMERIC(18,2) COMPUTED BY ((cast("Volume" * "Price" as numeric(10,2)))),
    "CurLimit"          "FuelVolume",
    "CurRest"           "FuelVolume",
    "deleted"           SMALLINT,
    "LastUpdate"        TIMESTAMP DEFAULT current_timestamp NOT NULL
);


CREATE TABLE FIB$ERROR_MESSAGES (
    CONSTRAINT_NAME  VARCHAR(67) NOT NULL,
    MESSAGE_STRING   VARCHAR(100),
    FIB$VERSION      INTEGER,
    CONSTR_TYPE      VARCHAR(11) DEFAULT 'UNIQUE' NOT NULL
);


CREATE TABLE "Fuel" (
    "FuelId"    "Key" NOT NULL,
    "FuelNo"    INTEGER NOT NULL,
    "FuelName"  VARCHAR(20) NOT NULL,
    "Price"     NUMERIC(7,2) DEFAULT 0 NOT NULL
);


CREATE TABLE "FuelIncome" (
    "Id"           "Key" NOT NULL,
    "OrgId"        "Key" NOT NULL,
    "AzsId"        "Key" NOT NULL,
    "TankId"       "Key" NOT NULL,
    "CardTransId"  "Key",
    "Date"         TIMESTAMP,
    "Doc"          VARCHAR(30),
    "DocDate"      DATE,
    "Supplier"     VARCHAR(30),
    "FuelId"       "Key",
    "Volume"       "FuelVolume",
    "deleted"      SMALLINT DEFAULT 0 NOT NULL
);


CREATE TABLE "FuelPriceByOrg" (
    "OrgId"   "Key" NOT NULL,
    "FuelId"  "Key" NOT NULL,
    "Price"   NUMERIC(7,2)
);


CREATE TABLE "FuelSale" (
    "Id"           "Key" NOT NULL,
    "OrgId"        "Key" NOT NULL,
    "AzsId"        "Key" NOT NULL,
    "TankId"       "Key" NOT NULL,
    "CardTransId"  "Key",
    "Date"         TIMESTAMP,
    "Doc"          VARCHAR(30),
    "DocDate"      DATE,
    "Client"       VARCHAR(30),
    "AutoId"       "Key",
    "FuelId"       "Key" NOT NULL,
    "Price"        NUMERIC(7,2),
    "Volume"       "FuelVolume",
    "Money"        NUMERIC(18,2) COMPUTED BY (cast("Volume" * "Price" as numeric(10,2))),
    "deleted"      SMALLINT DEFAULT 0 NOT NULL
);


CREATE TABLE "FuelStorage" (
    "OrgId"   "Key" NOT NULL,
    "FuelId"  "Key" NOT NULL,
    "Volume"  NUMERIC(8,2) NOT NULL
);


CREATE TABLE "FuelStorageInv" (
    "Id"           "Key" NOT NULL,
    "Date"         TIMESTAMP NOT NULL,
    "OrgId"        "Key" NOT NULL,
    "FuelId"       "Key" NOT NULL,
    "Volume"       DECIMAL(8,2) NOT NULL,
    "Description"  VARCHAR(255)
);


CREATE TABLE "FuelStorageMove" (
    "Id"           "Key" NOT NULL,
    "Date"         TIMESTAMP NOT NULL,
    "OrgFromId"    "Key" NOT NULL,
    "OrgToId"      "Key" NOT NULL,
    "FuelId"       "Key" NOT NULL,
    "Volume"       DECIMAL(8,2) NOT NULL,
    "Description"  VARCHAR(255)
);


CREATE TABLE "GsmModem" (
    "TerminalId"    "Key" NOT NULL,
    "TelNo"         VARCHAR(20),
    "USSD_Balance"  VARCHAR(20)
);


CREATE TABLE "Organization" (
    "OrgId"       "Key" NOT NULL,
    "Name"        VARCHAR(100) NOT NULL,
    "Inn"         VARCHAR(20),
    "Edrpou"      VARCHAR(20),
    "Svid"        VARCHAR(20),
    "Address"     VARCHAR(100),
    "Bank"        VARCHAR(100),
    "Acct"        VARCHAR(20),
    "Mfo"         VARCHAR(20),
    "Tel"         VARCHAR(20),
    "Director"    VARCHAR(50),
    "Buchgalter"  VARCHAR(50)
);


CREATE TABLE "Pump" (
    "PumpId"      "Key" NOT NULL,
    "TerminalId"  "Key" NOT NULL,
    "PumpNo"      INTEGER NOT NULL,
    "NozzleNo"    INTEGER NOT NULL,
    "TankId"      "Key" NOT NULL,
    "Counter"     "PumpCounter"
);


CREATE TABLE "Tank" (
    "TankId"       "Key" NOT NULL,
    "TankNo"       SMALLINT NOT NULL,
    "AzsId"        "Key" NOT NULL,
    "TerminalId"   "Key",
    "FuelId"       "Key" NOT NULL,
    "TotalHeight"  "TankLevel" NOT NULL,
    "TotalVolume"  "TankVolume" NOT NULL,
    "MinLevel"     "TankLevel" NOT NULL,
    "BookStateId"  "Key",
    "RealStateId"  "Key"
);


CREATE TABLE "TankBookStateHistory" (
    "TankStateId"  "Key" NOT NULL,
    "Date"         TIMESTAMP NOT NULL,
    "TankId"       "Key" NOT NULL,
    "FuelId"       "Key" NOT NULL
);


CREATE TABLE "TankCalibration" (
    "TankId"  "Key" NOT NULL,
    "Level"   "TankLevel" NOT NULL,
    "Volume"  "TankVolume"
);


CREATE TABLE "TankRealStateHistory" (
    "TankStateId"  "Key" NOT NULL,
    "Date"         TIMESTAMP NOT NULL,
    "TankId"       "Key" NOT NULL,
    "FuelId"       "Key" NOT NULL,
    "Locked"       SMALLINT NOT NULL
);


CREATE TABLE "TankState" (
    "TankStateId"  "Key" NOT NULL,
    "Status"       SMALLINT,
    "Level"        "TankLevel",
    "Volume"       "TankVolume",
    "Temperature"  "Temperature",
    "Density"      "Density",
    "WaterLevel"   "TankLevel",
    "WaterVolume"  "TankVolume"
);


CREATE TABLE "Terminal" (
    "TerminalId"   "Key" NOT NULL,
    "AzsId"        "Key" NOT NULL,
    "SerialNo"     VARCHAR(10) NOT NULL,
    "Name"         VARCHAR(30) NOT NULL,
    "Pid"          VARCHAR(10),
    "NetAdr"       SMALLINT NOT NULL,
    "Flags"        INTEGER,
    "LastTransNo"  INTEGER DEFAULT 0 NOT NULL,
    "SyncDate"     TIMESTAMP,
    "SyncStatus"   VARCHAR(255),
    "SyncOkDate"   TIMESTAMP
);


CREATE TABLE "User" (
    "UserId"       "Key" NOT NULL,
    "Active"       "TBoolean",
    "Name"         VARCHAR(20) NOT NULL,
    "Psw"          VARCHAR(20),
    "Permissions"  INTEGER
);


CREATE TABLE "vars" (
    "Name"   VARCHAR(30) NOT NULL,
    "Value"  VARCHAR(120)
);




/******************************************************************************/
/***                           Unique Constraints                           ***/
/******************************************************************************/

ALTER TABLE "Auto" ADD CONSTRAINT "UNQ1_Auto" UNIQUE ("Number");
ALTER TABLE "Auto" ADD CONSTRAINT "UNQ2_Auto" UNIQUE ("Pin");
ALTER TABLE "Card" ADD CONSTRAINT "UNQ1_Card" UNIQUE ("CardNo");
ALTER TABLE "Fuel" ADD CONSTRAINT "UNQ1_Fuel" UNIQUE ("FuelName");
ALTER TABLE "Fuel" ADD CONSTRAINT "UNQ2_Fuel" UNIQUE ("FuelNo");
ALTER TABLE "Organization" ADD CONSTRAINT "UNQ1_Organization" UNIQUE ("Name");
ALTER TABLE "Pump" ADD CONSTRAINT "UNQ1_Pump" UNIQUE ("TerminalId", "PumpNo", "NozzleNo");
ALTER TABLE "Terminal" ADD CONSTRAINT "UNQ3_Terminal" UNIQUE ("Name");
ALTER TABLE "User" ADD CONSTRAINT "UNQ1_User" UNIQUE ("Name");


/******************************************************************************/
/***                              Primary Keys                              ***/
/******************************************************************************/

ALTER TABLE "Auto" ADD CONSTRAINT "PK_Auto" PRIMARY KEY ("AutoId");
ALTER TABLE "Azs" ADD CONSTRAINT "PK_Azs" PRIMARY KEY ("AzsId");
ALTER TABLE "Card" ADD CONSTRAINT "PK_Card" PRIMARY KEY ("CardId");
ALTER TABLE "CardLimitTypes" ADD CONSTRAINT "PK_CardLimitTypes" PRIMARY KEY ("LimitTypeId");
ALTER TABLE "CardLimits" ADD CONSTRAINT "PK_CardLimits" PRIMARY KEY ("LimitId");
ALTER TABLE "CardOperationTypes" ADD CONSTRAINT "PK_CardOperationTypes" PRIMARY KEY ("OperId");
ALTER TABLE "CardTransaction" ADD CONSTRAINT "PK_CardTransaction" PRIMARY KEY ("TransId");
ALTER TABLE FIB$ERROR_MESSAGES ADD CONSTRAINT PK_FIB$ERROR_MESSAGES PRIMARY KEY (CONSTRAINT_NAME);
ALTER TABLE "Fuel" ADD CONSTRAINT "PK_Fuel" PRIMARY KEY ("FuelId");
ALTER TABLE "FuelIncome" ADD CONSTRAINT "PK_FuelIncome" PRIMARY KEY ("Id");
ALTER TABLE "FuelPriceByOrg" ADD CONSTRAINT "PK_FuelPriceByOrg" PRIMARY KEY ("OrgId", "FuelId");
ALTER TABLE "FuelSale" ADD CONSTRAINT "PK_FuelSale" PRIMARY KEY ("Id");
ALTER TABLE "FuelStorage" ADD CONSTRAINT "PK_FuelStorage" PRIMARY KEY ("OrgId", "FuelId");
ALTER TABLE "FuelStorageInv" ADD CONSTRAINT "PK_FuelStorageInv" PRIMARY KEY ("Id");
ALTER TABLE "FuelStorageMove" ADD CONSTRAINT "PK_FuelStorageMove" PRIMARY KEY ("Id");
ALTER TABLE "GsmModem" ADD CONSTRAINT "PK_GsmModem" PRIMARY KEY ("TerminalId");
ALTER TABLE "Organization" ADD CONSTRAINT "PK_Organization" PRIMARY KEY ("OrgId");
ALTER TABLE "Pump" ADD CONSTRAINT "PK_Pump" PRIMARY KEY ("PumpId");
ALTER TABLE "Tank" ADD CONSTRAINT "PK_Tank" PRIMARY KEY ("TankId");
ALTER TABLE "TankBookStateHistory" ADD CONSTRAINT "PK_TankBookStateHistory" PRIMARY KEY ("TankStateId");
ALTER TABLE "TankCalibration" ADD CONSTRAINT "PK_TankCalibration" PRIMARY KEY ("TankId", "Level");
ALTER TABLE "TankRealStateHistory" ADD CONSTRAINT "PK_TankRealStateHistory" PRIMARY KEY ("TankStateId");
ALTER TABLE "TankState" ADD CONSTRAINT "PK_TankState" PRIMARY KEY ("TankStateId");
ALTER TABLE "Terminal" ADD CONSTRAINT "PK_Terminal" PRIMARY KEY ("TerminalId");
ALTER TABLE "User" ADD CONSTRAINT "PK_User" PRIMARY KEY ("UserId");
ALTER TABLE "vars" ADD CONSTRAINT "PK_vars" PRIMARY KEY ("Name");


/******************************************************************************/
/***                              Foreign Keys                              ***/
/******************************************************************************/

ALTER TABLE "Card" ADD CONSTRAINT "FK_Card_1" FOREIGN KEY ("OperId") REFERENCES "CardOperationTypes" ("OperId");
ALTER TABLE "Card" ADD CONSTRAINT "FK_Card_3" FOREIGN KEY ("OrgId") REFERENCES "Organization" ("OrgId");
ALTER TABLE "CardLimits" ADD CONSTRAINT "FK_CardLimits_1" FOREIGN KEY ("CardId") REFERENCES "Card" ("CardId") ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE "CardLimits" ADD CONSTRAINT "FK_CardLimits_2" FOREIGN KEY ("LimitTypeId") REFERENCES "CardLimitTypes" ("LimitTypeId") ON UPDATE CASCADE;
ALTER TABLE "CardTerminals" ADD CONSTRAINT "FK_CardTerminals_1" FOREIGN KEY ("CardId") REFERENCES "Card" ("CardId") ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE "CardTerminals" ADD CONSTRAINT "FK_CardTerminals_2" FOREIGN KEY ("TerminalId") REFERENCES "Terminal" ("TerminalId") ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE "CardTransaction" ADD CONSTRAINT "FK_CardTransaction_1" FOREIGN KEY ("CardId") REFERENCES "Card" ("CardId");
ALTER TABLE "CardTransaction" ADD CONSTRAINT "FK_CardTransaction_10" FOREIGN KEY ("LimitType") REFERENCES "CardLimitTypes" ("LimitTypeId");
ALTER TABLE "CardTransaction" ADD CONSTRAINT "FK_CardTransaction_11" FOREIGN KEY ("OrgId") REFERENCES "Organization" ("OrgId");
ALTER TABLE "CardTransaction" ADD CONSTRAINT "FK_CardTransaction_2" FOREIGN KEY ("FuelId") REFERENCES "Fuel" ("FuelId") ON UPDATE CASCADE;
ALTER TABLE "CardTransaction" ADD CONSTRAINT "FK_CardTransaction_3" FOREIGN KEY ("TerminalId") REFERENCES "Terminal" ("TerminalId") ON UPDATE CASCADE;
ALTER TABLE "CardTransaction" ADD CONSTRAINT "FK_CardTransaction_4" FOREIGN KEY ("AzsId") REFERENCES "Azs" ("AzsId") ON UPDATE CASCADE;
ALTER TABLE "CardTransaction" ADD CONSTRAINT "FK_CardTransaction_5" FOREIGN KEY ("PumpId") REFERENCES "Pump" ("PumpId") ON UPDATE CASCADE;
ALTER TABLE "CardTransaction" ADD CONSTRAINT "FK_CardTransaction_6" FOREIGN KEY ("TankId") REFERENCES "Tank" ("TankId") ON UPDATE CASCADE;
ALTER TABLE "CardTransaction" ADD CONSTRAINT "FK_CardTransaction_7" FOREIGN KEY ("TankStateIdBegin") REFERENCES "TankState" ("TankStateId");
ALTER TABLE "CardTransaction" ADD CONSTRAINT "FK_CardTransaction_8" FOREIGN KEY ("TankStateIdEnd") REFERENCES "TankState" ("TankStateId");
ALTER TABLE "CardTransaction" ADD CONSTRAINT "FK_CardTransaction_9" FOREIGN KEY ("OperId") REFERENCES "CardOperationTypes" ("OperId");
ALTER TABLE "FuelIncome" ADD CONSTRAINT "FK_FuelIncome_1" FOREIGN KEY ("CardTransId") REFERENCES "CardTransaction" ("TransId");
ALTER TABLE "FuelIncome" ADD CONSTRAINT "FK_FuelIncome_2" FOREIGN KEY ("FuelId") REFERENCES "Fuel" ("FuelId");
ALTER TABLE "FuelIncome" ADD CONSTRAINT "FK_FuelIncome_3" FOREIGN KEY ("AzsId") REFERENCES "Azs" ("AzsId");
ALTER TABLE "FuelIncome" ADD CONSTRAINT "FK_FuelIncome_4" FOREIGN KEY ("TankId") REFERENCES "Tank" ("TankId");
ALTER TABLE "FuelIncome" ADD CONSTRAINT "FK_FuelIncome_5" FOREIGN KEY ("OrgId") REFERENCES "Organization" ("OrgId");
ALTER TABLE "FuelPriceByOrg" ADD CONSTRAINT "FK_FuelPriceByOrg_1" FOREIGN KEY ("OrgId") REFERENCES "Organization" ("OrgId") ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE "FuelPriceByOrg" ADD CONSTRAINT "FK_FuelPriceByOrg_2" FOREIGN KEY ("FuelId") REFERENCES "Fuel" ("FuelId") ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE "FuelSale" ADD CONSTRAINT "FK_FuelSale_1" FOREIGN KEY ("CardTransId") REFERENCES "CardTransaction" ("TransId");
ALTER TABLE "FuelSale" ADD CONSTRAINT "FK_FuelSale_2" FOREIGN KEY ("FuelId") REFERENCES "Fuel" ("FuelId") ON UPDATE CASCADE;
ALTER TABLE "FuelSale" ADD CONSTRAINT "FK_FuelSale_3" FOREIGN KEY ("AzsId") REFERENCES "Azs" ("AzsId") ON UPDATE CASCADE;
ALTER TABLE "FuelSale" ADD CONSTRAINT "FK_FuelSale_4" FOREIGN KEY ("TankId") REFERENCES "Tank" ("TankId") ON UPDATE CASCADE;
ALTER TABLE "FuelSale" ADD CONSTRAINT "FK_FuelSale_5" FOREIGN KEY ("AutoId") REFERENCES "Auto" ("AutoId");
ALTER TABLE "FuelSale" ADD CONSTRAINT "FK_FuelSale_6" FOREIGN KEY ("OrgId") REFERENCES "Organization" ("OrgId");
ALTER TABLE "FuelStorage" ADD CONSTRAINT "FK_FuelStorage_1" FOREIGN KEY ("OrgId") REFERENCES "Organization" ("OrgId") ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE "FuelStorage" ADD CONSTRAINT "FK_FuelStorage_2" FOREIGN KEY ("FuelId") REFERENCES "Fuel" ("FuelId") ON UPDATE CASCADE;
ALTER TABLE "FuelStorageInv" ADD CONSTRAINT "FK_FuelStorageInv_1" FOREIGN KEY ("OrgId") REFERENCES "Organization" ("OrgId") ON UPDATE CASCADE;
ALTER TABLE "FuelStorageInv" ADD CONSTRAINT "FK_FuelStorageInv_2" FOREIGN KEY ("FuelId") REFERENCES "Fuel" ("FuelId") ON UPDATE CASCADE;
ALTER TABLE "FuelStorageMove" ADD CONSTRAINT "FK_FuelStorageMove_1" FOREIGN KEY ("OrgFromId") REFERENCES "Organization" ("OrgId") ON UPDATE CASCADE;
ALTER TABLE "FuelStorageMove" ADD CONSTRAINT "FK_FuelStorageMove_2" FOREIGN KEY ("OrgToId") REFERENCES "Organization" ("OrgId") ON UPDATE CASCADE;
ALTER TABLE "FuelStorageMove" ADD CONSTRAINT "FK_FuelStorageMove_3" FOREIGN KEY ("FuelId") REFERENCES "Fuel" ("FuelId") ON UPDATE CASCADE;
ALTER TABLE "GsmModem" ADD CONSTRAINT "FK_GsmModem_1" FOREIGN KEY ("TerminalId") REFERENCES "Terminal" ("TerminalId") ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE "Pump" ADD CONSTRAINT "FK_Pump_2" FOREIGN KEY ("TerminalId") REFERENCES "Terminal" ("TerminalId") ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE "Pump" ADD CONSTRAINT "FK_Pump_3" FOREIGN KEY ("TankId") REFERENCES "Tank" ("TankId") ON UPDATE CASCADE;
ALTER TABLE "Tank" ADD CONSTRAINT "FK_Tank_1" FOREIGN KEY ("AzsId") REFERENCES "Azs" ("AzsId") ON UPDATE CASCADE;
ALTER TABLE "Tank" ADD CONSTRAINT "FK_Tank_2" FOREIGN KEY ("FuelId") REFERENCES "Fuel" ("FuelId") ON UPDATE CASCADE;
ALTER TABLE "Tank" ADD CONSTRAINT "FK_Tank_3" FOREIGN KEY ("RealStateId") REFERENCES "TankRealStateHistory" ("TankStateId");
ALTER TABLE "Tank" ADD CONSTRAINT "FK_Tank_4" FOREIGN KEY ("BookStateId") REFERENCES "TankBookStateHistory" ("TankStateId");
ALTER TABLE "Tank" ADD CONSTRAINT "FK_Tank_5" FOREIGN KEY ("TerminalId") REFERENCES "Terminal" ("TerminalId") ON UPDATE CASCADE;
ALTER TABLE "TankBookStateHistory" ADD CONSTRAINT "FK_TankBookStateHistory_1" FOREIGN KEY ("TankStateId") REFERENCES "TankState" ("TankStateId");
ALTER TABLE "TankBookStateHistory" ADD CONSTRAINT "FK_TankBookStateHistory_2" FOREIGN KEY ("TankId") REFERENCES "Tank" ("TankId") ON UPDATE CASCADE;
ALTER TABLE "TankBookStateHistory" ADD CONSTRAINT "FK_TankBookStateHistory_3" FOREIGN KEY ("FuelId") REFERENCES "Fuel" ("FuelId") ON UPDATE CASCADE;
ALTER TABLE "TankCalibration" ADD CONSTRAINT "FK_TankCalibration_1" FOREIGN KEY ("TankId") REFERENCES "Tank" ("TankId") ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE "TankRealStateHistory" ADD CONSTRAINT "FK_TankRealStateHistory_1" FOREIGN KEY ("TankStateId") REFERENCES "TankState" ("TankStateId");
ALTER TABLE "TankRealStateHistory" ADD CONSTRAINT "FK_TankRealStateHistory_2" FOREIGN KEY ("TankId") REFERENCES "Tank" ("TankId") ON UPDATE CASCADE;
ALTER TABLE "TankRealStateHistory" ADD CONSTRAINT "FK_TankRealStateHistory_3" FOREIGN KEY ("FuelId") REFERENCES "Fuel" ("FuelId") ON UPDATE CASCADE;
ALTER TABLE "Terminal" ADD CONSTRAINT "FK_Terminal_1" FOREIGN KEY ("AzsId") REFERENCES "Azs" ("AzsId") ON UPDATE CASCADE;


/******************************************************************************/
/***                                Indices                                 ***/
/******************************************************************************/

CREATE INDEX "CardTransaction_IDX1" ON "CardTransaction" ("DateBegin");
CREATE INDEX "FuelSale_IDX1" ON "FuelSale" ("Date");
CREATE INDEX "FuelStorageInv_IDX1" ON "FuelStorageInv" ("Date");
CREATE INDEX "TankBookStateHistory_IDX1" ON "TankBookStateHistory" ("Date");
CREATE INDEX "TankRealStateHistory_IDX1" ON "TankRealStateHistory" ("Date");
CREATE DESCENDING INDEX "TankRealStateHistory_IDX2" ON "TankRealStateHistory" ("Date");


/******************************************************************************/
/***                                Triggers                                ***/
/******************************************************************************/


SET TERM ^ ;



/******************************************************************************/
/***                          Triggers for tables                           ***/
/******************************************************************************/



/* Trigger: BI_FIB$ERROR_MESSAGES */
CREATE TRIGGER BI_FIB$ERROR_MESSAGES FOR FIB$ERROR_MESSAGES
ACTIVE BEFORE INSERT POSITION 0
AS 
begin 
new.fib$version=gen_id(fib$field_info_version,1);
end
^


/* Trigger: BU_FIB$ERROR_MESSAGES */
CREATE TRIGGER BU_FIB$ERROR_MESSAGES FOR FIB$ERROR_MESSAGES
ACTIVE BEFORE UPDATE POSITION 0
AS 
begin 
new.fib$version=gen_id(fib$field_info_version,1);
end
^


/* Trigger: "Card_BI0" */
CREATE TRIGGER "Card_BI0" FOR "Card"
ACTIVE BEFORE INSERT POSITION 0
AS
begin
 new."Version" = 0;
end
^


/* Trigger: "FuelIncome_AD0" */
CREATE TRIGGER "FuelIncome_AD0" FOR "FuelIncome"
ACTIVE AFTER DELETE POSITION 0
AS
begin
  if (old."deleted" <> 1)
    then execute procedure "TankBookState_U"(old."TankId", old."FuelId", old."Date", -old."Volume");
end
^


/* Trigger: "FuelIncome_AI0" */
CREATE TRIGGER "FuelIncome_AI0" FOR "FuelIncome"
ACTIVE AFTER INSERT POSITION 0
AS
begin
  execute procedure "TankBookState_U"(new."TankId", new."FuelId", new."Date", new."Volume");
  execute procedure "FuelStorage_Add"(new."OrgId", new."FuelId", new."Volume");
end
^


/* Trigger: "FuelIncome_AU0" */
CREATE TRIGGER "FuelIncome_AU0" FOR "FuelIncome"
ACTIVE AFTER UPDATE POSITION 0
AS
begin
 if (new."deleted" <> 0) then exit;
 if (old."TankId" <> new."TankId" or old."FuelId" <> new."FuelId" or
      old."Date" <> new."Date" or old."Volume" <> new."Volume" ) then begin
    execute procedure "TankBookState_U"(old."TankId", old."FuelId", old."Date", -old."Volume");
    execute procedure "TankBookState_U"(new."TankId", new."FuelId", new."Date", new."Volume");
 end
 if (old."OrgId" <> new."OrgId" or old."Volume" <> new."Volume") then begin
    execute procedure "FuelStorage_Add"(old."OrgId", old."FuelId", -old."Volume");
    execute procedure "FuelStorage_Add"(new."OrgId", new."FuelId", new."Volume");
 end
end
^


/* Trigger: "FuelIncome_BI0" */
CREATE TRIGGER "FuelIncome_BI0" FOR "FuelIncome"
ACTIVE BEFORE INSERT POSITION 0
AS
begin
 new."deleted" = 0;
end
^


/* Trigger: "FuelSale_AD0" */
CREATE TRIGGER "FuelSale_AD0" FOR "FuelSale"
ACTIVE AFTER DELETE POSITION 0
AS
begin
  if (old."deleted" = 1) then exit;
  execute procedure "TankBookState_U"(old."TankId", old."FuelId", old."Date", old."Volume");
  execute procedure "FuelStorage_Add"(old."OrgId", old."FuelId", old."Volume");
end
^


/* Trigger: "FuelSale_AI0" */
CREATE TRIGGER "FuelSale_AI0" FOR "FuelSale"
ACTIVE AFTER INSERT POSITION 0
AS
begin
  execute procedure "TankBookState_U"(new."TankId", new."FuelId", new."Date", -new."Volume");
  execute procedure "FuelStorage_Add"(new."OrgId", new."FuelId", -new."Volume");
end
^


/* Trigger: "FuelSale_AU0" */
CREATE TRIGGER "FuelSale_AU0" FOR "FuelSale"
ACTIVE AFTER UPDATE POSITION 0
AS
begin
 if (new."deleted" <> 0) then exit;
  if (old."TankId" <> new."TankId" or old."FuelId" <> new."FuelId" or
      old."Date" <> new."Date" or old."Volume" <> new."Volume" ) then begin
    execute procedure "TankBookState_U"(old."TankId", old."FuelId", old."Date", old."Volume");
    execute procedure "TankBookState_U"(new."TankId", new."FuelId", new."Date", -new."Volume");
  end
  if (old."OrgId" <> new."OrgId" or old."Volume" <> new."Volume") then begin
    execute procedure "FuelStorage_Add"(old."OrgId", old."FuelId", old."Volume");
    execute procedure "FuelStorage_Add"(new."OrgId", new."FuelId", -new."Volume");
  end
end
^


/* Trigger: "FuelSale_BI0" */
CREATE TRIGGER "FuelSale_BI0" FOR "FuelSale"
ACTIVE BEFORE INSERT POSITION 0
AS
begin
 new."deleted" = 0;
end
^


SET TERM ; ^



/******************************************************************************/
/***                           Stored Procedures                            ***/
/******************************************************************************/


SET TERM ^ ;

ALTER PROCEDURE "Auto_DEL" (
    "AutoId" INTEGER)
AS
begin
  delete from "Auto"
  where ("AutoId" = :"AutoId");
end^


ALTER PROCEDURE "Auto_IU" (
    "AutoId" INTEGER,
    "Pin" VARCHAR(6),
    "Number" VARCHAR(10),
    "Description" VARCHAR(255))
AS
begin
  if (exists(select "AutoId" from "Auto" where ("AutoId" = :"AutoId"))) then
    update "Auto"
    set "Pin" = :"Pin",
        "Number" = :"Number",
        "Description" = :"Description"
    where ("AutoId" = :"AutoId");
  else
    insert into "Auto" (
        "AutoId",
        "Pin",
        "Number",
        "Description")
    values (
        :"AutoId",
        :"Pin",
        :"Number",
        :"Description");
end^


ALTER PROCEDURE "Azs_DEL" (
    "AzsId" INTEGER)
AS
declare variable "termId" integer;
declare variable "id" integer;
begin
  for select "TerminalId" from "Terminal"
    where "AzsId" = :"AzsId"
      into :"termId"
  do begin
    for select "PumpId" from  "Pump" where "TerminalId" = :"termId" into :"id"
      do execute procedure "Pump_DEL"(:"id");
    for select "TankId" from  "Tank" where "TerminalId" = :"termId" into :"id"
      do execute procedure "Tank_DEL"(:"id");
    delete from "Terminal"  where ("TerminalId" = :"termId");
  end

  delete from "Azs" where ("AzsId" = :"AzsId");
end^


ALTER PROCEDURE "Azs_IU" (
    "AzsId" INTEGER,
    "Name" VARCHAR(30),
    "Owner" VARCHAR(30))
AS
begin
  if (exists(select "AzsId" from "Azs" where ("AzsId" = :"AzsId"))) then
    update "Azs"
    set "Name" = :"Name",
        "Owner" = :"Owner"
    where ("AzsId" = :"AzsId");
  else
    insert into "Azs" (
        "AzsId",
        "Name",
        "Owner")
    values (
        :"AzsId",
        :"Name",
        :"Owner");
end^


ALTER PROCEDURE "BookTankStateByDate" (
    "TankId" INTEGER,
    "FuelId" INTEGER,
    "Date" TIMESTAMP)
RETURNS (
    "TankStateId" INTEGER)
AS
begin
 "TankStateId" = null;
 for select h."TankStateId" from  "TankBookStateHistory" h
   where h."TankId" = :"TankId" and h."FuelId" = :"FuelId" and h."Date" <= :"Date"
   order by h."Date" desc
     into :"TankStateId"
 do
 begin
   break;
 end
  suspend;
end^


ALTER PROCEDURE "db_clear" (
    "ToDate" DATE)
AS
declare variable "tankState1" integer;
declare variable "tankState2" integer;
declare variable "tankId" integer;
begin
 update "FuelSale" set "deleted" = 1 where cast("Date" as date) < :"ToDate";
 update "FuelIncome" set "deleted" = 1 where cast("Date" as date) < :"ToDate";
 update "CardTransaction" set "deleted" = 1 where cast("Date" as date) < :"ToDate";

 delete from  "FuelSale" where "deleted" = 1;
 delete from  "FuelIncome" where "deleted" = 1;
 delete from  "CardTransaction" where "deleted" = 1;

 /*  TankState */
 for select "TankId" from "Tank" t
   into :"tankId"
 do begin
  "tankState1" = null;
  select h1."TankStateId" from "TankRealStateHistory" h1
    where h1."Date" < :"ToDate" and h1."TankId" = :"tankId"
     order by h1."Date" desc rows 1
       into :"tankState1";

  for select h1."TankStateId" from "TankRealStateHistory" h1
    where h1."Date" < :"ToDate" and h1."TankId" = :"tankId" and h1."TankStateId" <> :"tankState1"
      into :"tankState2"
  do begin
    delete from "TankRealStateHistory" where "TankStateId" = :"tankState2";
    delete from "TankState" where "TankStateId" = :"tankState2";
  end

  "tankState1" = null;
  select h1."TankStateId" from "TankBookStateHistory" h1
    where h1."Date" < :"ToDate" and h1."TankId" = :"tankId"
     order by h1."Date" desc rows 1
       into :"tankState1";

  for select h1."TankStateId" from "TankBookStateHistory" h1
    where h1."Date" < :"ToDate" and h1."TankId" = :"tankId" and h1."TankStateId" <> :"tankState1"
      into :"tankState2"
  do begin
    delete from "TankBookStateHistory" a where a."TankStateId" = :"tankState2";
    delete from "TankState" a where a."TankStateId" = :"tankState2";
  end
 end

 if (not exists (select 1 from "FuelSale") and not exists (select 1 from "FuelIncome"))  then
   execute procedure "db_make_book_state";

end^


ALTER PROCEDURE "db_make_book_state"
AS
declare variable "tankId" integer;
declare variable "fuelId" integer;
declare variable "dt" timestamp;
declare variable "v" numeric(7,2);
declare variable "id" integer;
declare variable "ost" numeric(15,2);
declare variable "tankStateId" integer;
declare variable "i" integer;
begin
 update "Tank" t set t."BookStateId" = null;

 for select b."TankStateId" from "TankBookStateHistory" b
   into :"i"
 do begin
   delete from "TankBookStateHistory" where "TankStateId" = :"i";
   delete from "TankState" where "TankStateId" = :"i";
 end

 for select s."TankId", s."FuelId",  s."Date", s."Volume"  from "FuelSale" s order by s."Date"
   into :"tankId", :"fuelId", :"dt", :"v"
 do begin
  execute procedure "TankBookState_U"(:"tankId", :"fuelId", :"dt", -:"v");
  /*
  "id" = GEN_ID("NEW_GENERATOR", 1);
  execute procedure  "BookTankStateByDate"(:"tankId", :"fuelId", :"dt") returning_values (:"tankStateId");
  select s."Volume"  from "TankState" s where s."TankStateId" = :"tankStateId" into :"ost";
  insert into NEW_TABLE("id",  "date",  "tankid", "volume",  "ostatok")   values (:"id", :"dt", :"tankId", -:"v", :"ost");
  */
 end

 for select s."TankId", s."FuelId", s."Date", s."Volume"  from "FuelIncome" s order by s."Date"
   into :"tankId", :"fuelId", :"dt", :"v"
 do begin
  execute procedure "TankBookState_U"(:"tankId", :"fuelId", :"dt", :"v");
  /*
  "id" = GEN_ID("NEW_GENERATOR", 1);
  execute procedure  "BookTankStateByDate"(:"tankId", :"fuelId", :"dt") returning_values (:"tankStateId");
  select s."Volume"  from "TankState" s where s."TankStateId" = :"tankStateId" into :"ost";
  insert into NEW_TABLE("id",  "date",  "tankid", "volume",  "ostatok") values (:"id", :"dt", :"tankId", :"v", :"ost");
  */
 end

end^


ALTER PROCEDURE "EnableCardOnTerminal" (
    "CardId" INTEGER,
    "TerminalId" INTEGER,
    "Enabled" INTEGER)
AS
begin
 if ("Enabled" = 0) then begin
   delete from "CardTerminals" where "TerminalId" = :"TerminalId" and "CardId" = :"CardId";
 end
 else begin
   if (not exists (select 1 from "CardTerminals" where "TerminalId" = :"TerminalId" and "CardId" = :"CardId"))
     then insert into "CardTerminals" ("TerminalId", "CardId") values (:"TerminalId", :"CardId");
 end
end^


ALTER PROCEDURE "ExistsCardLimitForTerminal" (
    "cardId" INTEGER,
    "terminalId" INTEGER)
RETURNS (
    "exists" INTEGER)
AS
declare variable "limitType" integer;
begin
 "exists" = 0;
 if (exists (select 1 from "CardTerminals" where "CardId" = :"cardId" and "TerminalId" = :"terminalId"))
  then "exists" = 1;
 suspend;
end^


ALTER PROCEDURE "Fuel_DEL" (
    "FuelId" INTEGER)
AS
begin
  delete from "Fuel"
  where ("FuelId" = :"FuelId");
end^


ALTER PROCEDURE "Fuel_IU" (
    "FuelId" INTEGER,
    "FuelNo" INTEGER,
    "FuelName" VARCHAR(20),
    "Price" NUMERIC(7,2))
AS
begin
  if (exists(select "FuelId" from "Fuel" where ("FuelId" = :"FuelId"))) then
    update "Fuel"
    set "FuelNo" = :"FuelNo",
        "FuelName" = :"FuelName",
        "Price" = :"Price"
    where ("FuelId" = :"FuelId");
  else
    insert into "Fuel" (
        "FuelId",
        "FuelNo",
        "FuelName",
        "Price")
    values (
        :"FuelId",
        :"FuelNo",
        :"FuelName",
        :"Price");
end^


ALTER PROCEDURE "FuelIncome_DEL" (
    "Id" INTEGER)
AS
begin
  delete from "FuelIncome"
  where ("Id" = :"Id");
end^


ALTER PROCEDURE "FuelIncome_IU" (
    "Id" INTEGER,
    "OrgId" INTEGER,
    "TankId" INTEGER,
    "Date" TIMESTAMP,
    "Doc" VARCHAR(30),
    "DocDate" DATE,
    "Supplier" VARCHAR(30),
    "Volume" NUMERIC(7,2))
AS
declare variable "azsId" integer;
declare variable "fuelId" integer;
begin
 select "AzsId", "FuelId" from "Tank"  where "TankId" = :"TankId" into :"azsId", :"fuelId";

  if (exists(select "Id" from "FuelIncome" where ("Id" = :"Id"))) then
    update "FuelIncome"
    set "AzsId" = :"azsId",
        "OrgId" = :"OrgId",
        "TankId" = :"TankId",
        "Date" = :"Date",
        "Doc" = :"Doc",
        "DocDate" = :"DocDate",
        "Supplier" = :"Supplier",
        "FuelId" = :"fuelId",
        "Volume" = :"Volume"
    where ("Id" = :"Id");
  else
    insert into "FuelIncome" (
        "Id",
        "OrgId",
        "AzsId",
        "TankId",
        "Date",
        "Doc",
        "DocDate",
        "Supplier",
        "FuelId",
        "Volume")
    values (
        :"Id",
        :"OrgId",
        :"azsId",
        :"TankId",
        :"Date",
        :"Doc",
        :"DocDate",
        :"Supplier",
        :"fuelId",
        :"Volume");
end^


ALTER PROCEDURE "FuelPriceByOrg_U" (
    "OrgId" INTEGER,
    "FuelId" INTEGER,
    "Price" NUMERIC(7,2))
AS
begin
 if (("OrgId" is null) or ("OrgId" = 0))
    then update "Fuel" set "Price" = :"Price" where "FuelId" = :"FuelId";
  else begin
    if ((exists (select 1 from "FuelPriceByOrg" where "OrgId" = :"OrgId" and "FuelId" = :"FuelId" )))
      then update "FuelPriceByOrg" set "Price" = :"Price" where "OrgId" = :"OrgId" and "FuelId" = :"FuelId";
      else insert into "FuelPriceByOrg" ("OrgId", "FuelId", "Price") values (:"OrgId", :"FuelId", :"Price");
  end
end^


ALTER PROCEDURE "FuelSale_DEL" (
    "Id" INTEGER)
AS
begin
  delete from "FuelSale"
  where ("Id" = :"Id");
end^


ALTER PROCEDURE "FuelSale_IU" (
    "Id" INTEGER,
    "AzsId" INTEGER,
    "TankId" INTEGER,
    "OrgId" INTEGER,
    "Date" TIMESTAMP,
    "Doc" VARCHAR(30),
    "DocDate" DATE,
    "Client" VARCHAR(30),
    "AutoId" INTEGER,
    "FuelId" INTEGER,
    "Price" NUMERIC(7,2),
    "Volume" NUMERIC(7,2))
AS
begin
  if (exists(select "Id" from "FuelSale" where ("Id" = :"Id"))) then
    update "FuelSale"
    set
        "OrgId" = :"OrgId",
        "AzsId" = :"AzsId",
        "TankId" = :"TankId",
        "Date" = :"Date",
        "Doc" = :"Doc",
        "DocDate" = :"DocDate",
        "Client" = :"Client",
        "AutoId" = :"AutoId",
        "FuelId" = :"FuelId",
        "Price" = :"Price",
        "Volume" = :"Volume"
    where ("Id" = :"Id");
  else
    insert into "FuelSale" (
        "Id",
        "OrgId",
        "AzsId",
        "TankId",
        "Date",
        "Doc",
        "DocDate",
        "Client",
        "AutoId",
        "FuelId",
        "Price",
        "Volume")
    values (
        :"Id",
        :"OrgId",
        :"AzsId",
        :"TankId",
        :"Date",
        :"Doc",
        :"DocDate",
        :"Client",
        :"AutoId",
        :"FuelId",
        :"Price",
        :"Volume");
end^


ALTER PROCEDURE "FuelStorage_Add" (
    "OrgId" INTEGER,
    "FuelId" INTEGER,
    "Volume" NUMERIC(8,2))
AS
declare variable "v" numeric(8,2);
begin
 select "Volume" from "FuelStorage" where "OrgId" = :"OrgId" and "FuelId" = :"FuelId"
  into :"v";
 if ("v" is null) then "v" = 0;
 "v" = "v" + "Volume";
 execute procedure "FuelStorage_U"(:"OrgId", :"FuelId", :"v");
end^


ALTER PROCEDURE "FuelStorage_Inv" (
    "OrgId" INTEGER,
    "FuelId" INTEGER,
    "Volume" NUMERIC(8,2),
    "Description" VARCHAR(255))
AS
begin
 execute procedure "FuelStorage_U"(:"OrgId", :"FuelId", :"Volume");
 insert into "FuelStorageInv" ("Id", "Date", "OrgId",  "FuelId", "Volume", "Description")
  values (GEN_ID("GEN_Doc_Id", 1), current_timestamp, :"OrgId", :"FuelId", :"Volume", :"Description");
end^


ALTER PROCEDURE "FuelStorage_Move" (
    "OrgFromId" INTEGER,
    "OrgToId" INTEGER,
    "FuelId" INTEGER,
    "Volume" NUMERIC(8,2),
    "Description" VARCHAR(255))
AS
begin
  execute procedure "FuelStorage_Add"(:"OrgFromId", :"FuelId", -:"Volume");
  execute procedure "FuelStorage_Add"(:"OrgToId", :"FuelId", :"Volume");
 insert into "FuelStorageMove" ("Id", "Date", "OrgFromId",  "OrgToId", "FuelId", "Volume", "Description")
  values (GEN_ID("GEN_Doc_Id", 1), current_timestamp, :"OrgFromId", :"OrgToId", :"FuelId", :"Volume", :"Description");
end^


ALTER PROCEDURE "FuelStorage_U" (
    "OrgId" INTEGER,
    "FuelId" INTEGER,
    "Volume" NUMERIC(8,2))
AS
begin
  if ((exists(select 1 from "FuelStorage" where "OrgId" = :"OrgId" and "FuelId" = :"FuelId")))
   then update "FuelStorage" set "Volume" = :"Volume" where ("OrgId" = :"OrgId") and ("FuelId" = :"FuelId");
   else insert into "FuelStorage" ("OrgId", "FuelId", "Volume") values (:"OrgId", :"FuelId", :"Volume");
end^


ALTER PROCEDURE "Pump_DEL" (
    "PumpId" INTEGER)
AS
begin
  delete from "Pump"
  where ("PumpId" = :"PumpId");
end^


ALTER PROCEDURE "Pump_IU" (
    "PumpId" INTEGER,
    "TerminalId" INTEGER,
    "PumpNo" INTEGER,
    "NozzleNo" INTEGER,
    "TankId" INTEGER)
AS
declare variable "termAzsId" integer;
declare variable "tankAzsId" integer;
declare variable "oldTerminalId" integer;
begin
 select "TerminalId" from "Pump" where "PumpId" = :"PumpId" into :"oldTerminalId";
 if ("TerminalId" <> "oldTerminalId") then begin
   if (exists (select 1 from "CardTransaction" where "TerminalId" = :"TerminalId" ))
     then exception  "pumpChgErr";
 end

 select "AzsId" from "Terminal" where "TerminalId" = :"TerminalId" into :"termAzsId";
 select "AzsId" from "Tank" where "TankId" = :"TankId"  into :"tankAzsId";
 if ("termAzsId" <> "tankAzsId")
  then exception "pumpTankIdErr";

 if (exists(select "PumpId" from "Pump" where ("PumpId" = :"PumpId"))) then
    update "Pump"
    set "TerminalId" = :"TerminalId",
        "PumpNo" = :"PumpNo",
        "NozzleNo" = :"NozzleNo",
        "TankId" = :"TankId"
    where ("PumpId" = :"PumpId");
  else
    insert into "Pump" (
        "PumpId",
        "TerminalId",
        "PumpNo",
        "NozzleNo",
        "TankId")
    values (
        :"PumpId",
        :"TerminalId",
        :"PumpNo",
        :"NozzleNo",
        :"TankId");
end^


ALTER PROCEDURE "Pump_setCounter" (
    "PumpId" INTEGER,
    "Date" TIMESTAMP,
    "Counter" NUMERIC(9,2),
    "Volume" NUMERIC(7,2))
AS
declare variable "oldCounter" numeric(9,2);
declare variable "terminalId" integer;
declare variable "tankId" integer;
declare variable "fuelId" integer;
declare variable "transId" integer;
declare variable "azsId" integer;
declare variable "dCounter" numeric(9,2);
begin
 select p."Counter" from "Pump" p
  where p."PumpId" = :"PumpId"
   into :"oldCounter";
 if ("Counter" > 0) then begin
   "dCounter" = "Counter" - "oldCounter";
   if ("dCounter" <> "Volume") then begin
     select t."TerminalId", t."AzsId" from "Terminal" t, "Pump" p
       where p."PumpId" = :"PumpId" and t."TerminalId" = p."TerminalId"
       into :"terminalId", :"azsId";
     select t."TankId", t."FuelId" from "Pump" p, "Tank" t
       where p."PumpId" = :"PumpId" and t."TankId" = p."TankId"
       into :"tankId", :"fuelId";
     "transId" = GEN_ID("GEN_TransId", 1);
     insert into "CardTransaction" ("TransId", "CardId", "OrgId", "AzsId", "TerminalId",
        "TerminalTransNo", "PumpId", "FuelId", "TankId", "OperId", "DateBegin",
        "DateEnd", "CounterBegin", "CounterEnd", "TankStateIdBegin",
        "TankStateIdEnd", "Volume", "Price", "CurLimit", "CurRest")
      values (:"transId", -1, 0, :"azsId", :"terminalId",
        null, :"PumpId", :"fuelId", :"tankId", 4, :"Date",
        :"Date", :"oldCounter", :"Counter", null,
        null, :"dCounter" - :"Volume", 0, 0, 0);
   end
 end
 update "Pump" set "Counter" = :"Counter" where "PumpId" = :"PumpId";
end^


ALTER PROCEDURE "Tank_DEL" (
    "TankId" INTEGER)
AS
declare variable "bookStateId" integer;
declare variable "realStateId" integer;
declare variable "stateId" integer;
begin
 select "BookStateId", "RealStateId" from "Tank" where "TankId" = :"TankId"
  into :"bookStateId", :"realStateId";
 update "Tank" set "BookStateId" = null, "RealStateId" = null where "TankId" = :"TankId";

 for select "TankStateId" from "TankRealStateHistory" where "TankId" =:"TankId" into :"stateId"
 do begin
   delete from "TankRealStateHistory" where "TankStateId" = :"stateId";
   delete from "TankState" where "TankStateId" = :"stateId";
 end

 for select "TankStateId" from "TankBookStateHistory" where "TankId" =:"TankId" into :"stateId"
 do begin
   delete from "TankBookStateHistory" where "TankStateId" = :"stateId";
   delete from "TankState" where "TankStateId" = :"stateId";
 end

 delete from "TankState" where "TankStateId" = :"bookStateId" or "TankStateId" = :"realStateId";
 delete from "Tank"  where "TankId" = :"TankId";
end^


ALTER PROCEDURE "Tank_IU" (
    "TankId" INTEGER,
    "TankNo" SMALLINT,
    "AzsId" INTEGER,
    "TerminalId" INTEGER,
    "FuelId" INTEGER,
    "TotalHeight" INTEGER,
    "TotalVolume" INTEGER,
    "MinLevel" INTEGER)
AS
declare variable "oldAzsId" integer;
declare variable "bookStateId" integer;
declare variable "realStateId" integer;
begin
 select "AzsId" from "Tank" where "TankId" = :"TankId" into :"oldAzsId";
 if ("AzsId" <> "oldAzsId") then begin
   if (exists (select 1 from  "Pump" where "TankId" = :"TankId"))
    then exception "tankAzsIdErr";
 end
 if ("TerminalId" is not null) then begin
   if (not exists (select 1 from "Terminal" where "TerminalId" = :"TerminalId" and "AzsId" = :"AzsId"))
    then exception "tankTerminalIdErr";
 end

 if (exists(select "TankId" from "Tank" where ("TankId" = :"TankId"))) then
    update "Tank"
    set "TankNo" = :"TankNo",
        "AzsId" = :"AzsId",
        "TerminalId" = :"TerminalId",
        "FuelId" = :"FuelId",
        "TotalHeight" = :"TotalHeight",
        "TotalVolume" = :"TotalVolume",
        "MinLevel" = :"MinLevel"
    where ("TankId" = :"TankId");
  else begin
    insert into "Tank" (
        "TankId",
        "TankNo",
        "AzsId",
        "TerminalId",
        "FuelId",
        "TotalHeight",
        "TotalVolume",
        "MinLevel")
    values (
        :"TankId",
        :"TankNo",
        :"AzsId",
        :"TerminalId",
        :"FuelId",
        :"TotalHeight",
        :"TotalVolume",
        :"MinLevel");
     execute procedure "TankState_INS"(:"TankId", 0, 0, null, 20, 0.71, 0, null) returning_values (:"bookStateId");
     insert into "TankBookStateHistory" ("TankStateId", "Date", "TankId", "FuelId") values (:"bookStateId", current_timestamp, :"TankId", :"FuelId");
     execute procedure "TankState_INS"(:"TankId", 0, 0, null, 20, 0.71, 0, null) returning_values (:"realStateId");
     insert into "TankRealStateHistory" ("TankStateId", "Date", "TankId", "FuelId", "Locked") values (:"realStateId", current_timestamp, :"TankId", :"FuelId", 0);
     update "Tank" t set "BookStateId" = :"bookStateId", "RealStateId" = :"realStateId" where "TankId" = :"TankId";
  end
end^


ALTER PROCEDURE "Tank_l2mm" (
    "TankId" INTEGER,
    "Volume" NUMERIC(6,2))
RETURNS (
    "Level" NUMERIC(5,1))
AS
declare variable "Level1" numeric(5,1);
declare variable "Level2" numeric(5,1);
declare variable "Volume1" numeric(6,2);
declare variable "Volume2" numeric(6,2);
begin
 select c."Level", c."Volume"
  from "TankCalibration" c
   where c."TankId" = :"TankId" and c."Volume" <= :"Volume"
     order by c."Level" desc
      rows 1
       into :"Level1", :"Volume1";

 select c."Level", c."Volume"
   from "TankCalibration" c
    where c."TankId" = :"TankId" and c."Volume" >= :"Volume"
     order by c."Level" asc
      rows 1
        into :"Level2", :"Volume2";

  if ("Level1" is null) then
   "Level" = 0;
  else if ("Level2" is null) then
    select t."TotalHeight" from "Tank" t where t."TankId" = :"TankId"
     into :"Level";
  else if ("Volume1" = "Volume2")
   then "Level" = "Level1";
   else "Level" = "Level1" + ("Level2" - "Level1") / ("Volume2" - "Volume1") * ("Volume" - "Volume1");
  suspend;
end^


ALTER PROCEDURE "Tank_mm2l" (
    "TankId" INTEGER,
    "Level" NUMERIC(5,1))
RETURNS (
    "Volume" NUMERIC(6,2))
AS
declare variable "Level1" numeric(5,1);
declare variable "Level2" numeric(5,1);
declare variable "Volume1" numeric(6,2);
declare variable "Volume2" numeric(6,2);
begin
 if (("Level" < 0) or ("Level" is null))
   then "Level" = 0;

 select c."Level", c."Volume"
  from "TankCalibration" c
   where c."TankId" = :"TankId" and c."Level" <= :"Level"
     order by c."Level" desc
      rows 1
       into :"Level1", :"Volume1";

 select c."Level", c."Volume"
   from "TankCalibration" c
    where c."TankId" = :"TankId" and c."Level" >= :"Level"
     order by c."Level" asc
      rows 1
        into :"Level2", :"Volume2";

  if ("Volume1" is null) then
   begin
    "Level1" = 0;
    "Volume1" = 0;
   end

  if ("Volume2" is null) then
   begin
    "Level2" = "Level1";
    "Volume2" = "Volume1";
   end

  if ("Level1" = "Level2")
   then "Volume" = "Volume1";
   else "Volume" = "Volume1" + ("Volume2" - "Volume1") / ("Level2" - "Level1") * ("Level" - "Level1");
  suspend;
end^


ALTER PROCEDURE "TankBookState_U" (
    "TankId" INTEGER,
    "FuelId" INTEGER,
    "Date" TIMESTAMP,
    "DVolume" NUMERIC(7,2))
AS
declare variable "date" date;
declare variable "tankStateId" integer;
declare variable "oldTankStateId" integer;
declare variable "i" integer;
declare variable "fv" numeric(7,2);
declare variable "fl" numeric(5,1);
begin
 "date" = "Date";
 execute procedure  "BookTankStateByDate"(:"TankId", :"FuelId", :"date") returning_values (:"oldTankStateId");
 if ("oldTankStateId" is null) then begin
   execute procedure "TankState_INS"(:"TankId", 0, 0, 0, null, null, null, null) returning_values (:"tankStateId");
   insert into "TankBookStateHistory" ("TankStateId", "Date", "TankId", "FuelId") values (:"tankStateId", :"date", :"TankId", :"FuelId");
 end
 else if (exists(select 1 from "TankBookStateHistory" b where b."TankStateId" = :"oldTankStateId" and  b."Date" = :"date"))
   then "tankStateId" = "oldTankStateId";
 else begin
   execute procedure "TankState_COPY"(:"oldTankStateId") returning_values (:"tankStateId");
   insert into "TankBookStateHistory" ("TankStateId", "Date", "TankId", "FuelId") values (:"tankStateId", :"date", :"TankId", :"FuelId");
 end

 select "Volume" from "TankState" where "TankStateId" = :"tankStateId" into :"fv";
 "fv" = "fv" + "DVolume";
 execute procedure "Tank_l2mm"(:"TankId", :"fv") returning_values (:"fl");
 update "TankState" set "Level" = :"fl", "Volume" = :"fv" where "TankStateId" = :"tankStateId";

 for select h."TankStateId", ts."Volume"
   from "TankBookStateHistory" h, "TankState" ts where h."TankId" = :"TankId" and h."Date" > :"date" and ts."TankStateId" = h."TankStateId"
    into :"i", :"fv"
 do
  begin
    "fv" = "fv" + "DVolume";
    execute procedure "Tank_l2mm"(:"TankId", :"fv") returning_values (:"fl");
    update "TankState" set "Level" = :"fl", "Volume" = :"fv" where "TankStateId" = :"i";
  end

 if (not exists (
      select 1 from "Tank" t, "TankBookStateHistory" h
        where t."TankId" = :"TankId" and h."TankStateId" = t."BookStateId" and h."Date" > :"date"
     ))
 then update "Tank" set "BookStateId" = :"tankStateId" where "TankId" = :"TankId";

end^


ALTER PROCEDURE "TankCalibration_DEL" (
    "TankId" INTEGER)
AS
begin
  delete from "TankCalibration"
  where "TankId" = :"TankId";
end^


ALTER PROCEDURE "TankCalibration_INS" (
    "TankId" INTEGER,
    "Level" NUMERIC(5,1),
    "Volume" NUMERIC(6,2))
AS
begin
  insert into "TankCalibration" (
    "TankId",
    "Level",
    "Volume")
  values (
    :"TankId",
    :"Level",
    :"Volume");
end^


ALTER PROCEDURE "TankRealState_INS" (
    "TankId" INTEGER,
    "Date" TIMESTAMP,
    "Status" INTEGER,
    "Level" NUMERIC(5,1),
    "Volume" NUMERIC(6,2),
    "Temperature" NUMERIC(3,1),
    "Density" NUMERIC(4,4),
    "WaterLevel" NUMERIC(5,1),
    "WaterVolume" NUMERIC(6,2))
RETURNS (
    "TankStateId" INTEGER)
AS
declare variable "dt" timestamp;
declare variable "fuelId" integer;
begin
 execute procedure "TankState_INS"(:"TankId", :"Status", :"Level", :"Volume", :"Temperature",
   :"Density", :"WaterLevel", :"WaterVolume") returning_values (:"TankStateId");
 select "FuelId" from "Tank" where "TankId" = :"TankId" into :"fuelId";
 insert into "TankRealStateHistory" ("TankStateId", "Date", "TankId", "FuelId") values (:"TankStateId", :"Date", :"TankId", :"fuelId");

 select rsh."Date"
   from "Tank" t, "TankRealStateHistory" rsh
  where t."TankId" = :"TankId" and rsh."TankStateId" =  t."RealStateId"
   into :"dt";

 if ("dt" is null or "dt" < "Date" )
  then update "Tank" set "RealStateId" = :"TankStateId" where "TankId" = :"TankId";

end^


ALTER PROCEDURE "TankRealState_U" (
    "TankId" INTEGER,
    "Date" TIMESTAMP,
    "Status" INTEGER,
    "Level" NUMERIC(5,1),
    "Volume" NUMERIC(6,2),
    "Temperature" NUMERIC(3,1),
    "Density" NUMERIC(4,4),
    "WaterLevel" NUMERIC(5,1),
    "WaterVolume" NUMERIC(6,2),
    "Locked" SMALLINT)
RETURNS (
    "TankStateId" INTEGER)
AS
declare variable "fuelId" integer;
declare variable "oldTankStateId" integer;
declare variable "oldDate" timestamp;
declare variable "oldLocked" smallint;
begin
 if (:"Date" > current_timestamp)
   then exit;/* exception "dateInFuture";*/

 if (("Volume" is null) or ("Volume" = 0) )
   then   execute procedure "Tank_mm2l"(:"TankId", :"Level") returning_values (:"Volume");

 if ("WaterVolume" is null)
   then   execute procedure "Tank_mm2l"(:"TankId", :"WaterLevel") returning_values (:"WaterVolume");

 select h."TankStateId", h."Date", h."FuelId", coalesce(h."Locked", 0)
   from  "TankRealStateHistory" h
  where h."Date" = (select max(h2."Date") from "TankRealStateHistory" h2 where h2."TankId" = :"TankId" and h2."Date" <= :"Date")
    and h."TankId" = :"TankId"
    into :"oldTankStateId", :"oldDate", :"fuelId", :"oldLocked";
 if ("fuelId" is null)
  then select "FuelId" from "Tank" where "TankId" = :"TankId" into :"fuelId";

 "oldLocked" = 0;
 if (("oldLocked" = 0) and (cast(:"oldDate" as date) = cast(:"Date" as date))
 ) then begin
   "TankStateId" = "oldTankStateId";
   update "TankState" set "Status" = :"Status", "Level" = :"Level", "Volume" = :"Volume",
     "Temperature" = :"Temperature", "Density" = :"Density", "WaterLevel" = :"WaterLevel",
     "WaterVolume" = :"WaterVolume" where  "TankStateId" = :"TankStateId";
   update "TankRealStateHistory" set "Date" = :"Date", "Locked" = :"Locked" where "TankStateId" = :"TankStateId";
 end
 else begin
   execute procedure "TankState_INS"(:"TankId", :"Status", :"Level", :"Volume", :"Temperature",
     :"Density", :"WaterLevel", :"WaterVolume") returning_values (:"TankStateId");
   insert into "TankRealStateHistory" ("TankStateId", "Date", "TankId", "FuelId", "Locked") values (:"TankStateId", :"Date", :"TankId", :"fuelId", :"Locked");
 end

 if (not exists (
      select rsh."Date"
        from "Tank" t, "TankRealStateHistory" rsh
        where t."TankId" = :"TankId" and rsh."TankStateId" =  t."RealStateId" and rsh."Date" > :"Date"
    )) then begin
   update "Tank" set "RealStateId" = :"TankStateId" where "TankId" = :"TankId";
 end
end^


ALTER PROCEDURE "TankState_COPY" (
    "SrcTankStateId" INTEGER)
RETURNS (
    "DstTankStateId" INTEGER)
AS
begin
  "DstTankStateId" = GEN_ID("GEN_TankState_Id", 1);
  insert into "TankState"
/*  (
    "TankStateId",
    "Status",
    "Level",
    "Volume",
    "Temperature",
    "Density",
    "WaterLevel",
    "WaterVolume")
*/
    select
      :"DstTankStateId",
      t."Status",
      t."Level",
      t."Volume",
      t."Temperature",
      t."Density",
      t."WaterLevel",
      t."WaterVolume"
     from "TankState" t
      where t."TankStateId" = :"SrcTankStateId";
end^


ALTER PROCEDURE "TankState_INS" (
    "TankId" INTEGER,
    "Status" INTEGER,
    "Level" NUMERIC(5,1),
    "Volume" NUMERIC(6,2),
    "Temperature" NUMERIC(3,1),
    "Density" NUMERIC(4,4),
    "WaterLevel" NUMERIC(5,1),
    "WaterVolume" NUMERIC(6,2))
RETURNS (
    "TankStateId" INTEGER)
AS
begin
  "TankStateId" = GEN_ID("GEN_TankState_Id", 1);
  if ("Volume" is null and "Level" is not null)
   then execute procedure "Tank_mm2l"(:"TankId", :"Level") returning_values (:"Volume");
  if ("WaterVolume" is null and "WaterLevel" is not null)
   then execute procedure "Tank_mm2l"(:"TankId", :"WaterLevel") returning_values (:"WaterVolume");

  insert into "TankState" (
    "TankStateId",
    "Status",
    "Level",
    "Volume",
    "Temperature",
    "Density",
    "WaterLevel",
    "WaterVolume")
  values (
    :"TankStateId",
    :"Status",
    :"Level",
    :"Volume",
    :"Temperature",
    :"Density",
    :"WaterLevel",
    :"WaterVolume");
end^


ALTER PROCEDURE "TankStateHistoryByDate" (
    "Date" TIMESTAMP,
    "Compare" SMALLINT,
    "HistoryTableType" VARCHAR(10))
RETURNS (
    "TankId" INTEGER,
    "TankStateDate" TIMESTAMP,
    "TankStateId" INTEGER)
AS
begin
 for select t."TankId" from "Tank" t into :"TankId"
 do
  begin
   "TankStateDate" = null;
   "TankStateId" = null;

   if ("HistoryTableType" = 'real') then begin
     if ("Compare" < 0) then begin
       select b."Date", b."TankStateId" from "TankRealStateHistory" b
         where b."TankId" = :"TankId" and b."Date" < :"Date" order by b."Date" desc rows 1
           into :"TankStateDate", :"TankStateId";
     end
     else begin
       select b."Date", b."TankStateId" from "TankRealStateHistory" b
         where b."TankId" = :"TankId" and b."Date" > :"Date" order by b."Date" desc rows 1
           into :"TankStateDate", :"TankStateId";
     end
   end
   else if ("HistoryTableType" = 'book') then begin
     if ("Compare" < 0) then begin
       select b."Date", b."TankStateId" from "TankBookStateHistory" b
         where b."TankId" = :"TankId" and b."Date" < :"Date" order by b."Date" desc rows 1
           into :"TankStateDate", :"TankStateId";
     end
     else begin
       select b."Date", b."TankStateId" from "TankBookStateHistory" b
         where b."TankId" = :"TankId" and b."Date" > :"Date" order by b."Date" desc rows 1
           into :"TankStateDate", :"TankStateId";
     end
   end
   suspend;
  end

end^


ALTER PROCEDURE "Terminal_Add_TankState" (
    "TerminalId" INTEGER,
    "TankNo" INTEGER,
    "Date" TIMESTAMP,
    "Status" INTEGER,
    "Level" NUMERIC(5,1),
    "Volume" NUMERIC(6,2),
    "Temperature" NUMERIC(3,1),
    "Density" NUMERIC(4,4),
    "WaterLevel" NUMERIC(5,1),
    "Locked" SMALLINT)
AS
declare variable "tankId" integer;
declare variable "tankStateId" integer;
begin
 if ("Density" = 0)
   then "Density" = null;
 if (:"TankNo" = 0)
  then select "TankId" from "Tank" t where t."TerminalId" = :"TerminalId" rows 1 into :"tankId";
 else select "TankId" from "Tank" t where t."TerminalId" = :"TerminalId" and "TankNo" = :"TankNo" into :"tankId";
 execute procedure "TankRealState_U"(:"tankId", :"Date", :"Status", :"Level", :"Volume", :"Temperature", :"Density", :"WaterLevel", null, :"Locked") returning_values (:"tankStateId");
end^


ALTER PROCEDURE "Terminal_Add_Transaction" (
    "TerminalId" INTEGER,
    "TerminalTransNo" INTEGER,
    "CardNo" VARCHAR(20),
    "PumpId" INTEGER,
    "TankId" INTEGER,
    "FuelId" INTEGER,
    "OperId" INTEGER,
    "Volume" NUMERIC(7,2),
    "AutoType" INTEGER,
    "Auto" VARCHAR(20),
    "CurLimit" NUMERIC(7,2),
    "CurRest" NUMERIC(7,2),
    "DateBegin" TIMESTAMP,
    "DateEnd" TIMESTAMP,
    "CounterBegin" NUMERIC(15,2),
    "CounterEnd" NUMERIC(15,2),
    "TankStatusBegin" INTEGER,
    "LevelBegin" NUMERIC(5,1),
    "VolumeBegin" NUMERIC(6,2),
    "TemperatureBegin" NUMERIC(3,1),
    "DensityBegin" NUMERIC(4,4),
    "WaterLevelBegin" NUMERIC(5,1),
    "TankStatusEnd" INTEGER,
    "LevelEnd" NUMERIC(5,1),
    "VolumeEnd" NUMERIC(6,2),
    "TemperatureEnd" NUMERIC(3,1),
    "DensityEnd" NUMERIC(4,4),
    "WaterLevelEnd" NUMERIC(5,1))
AS
declare variable "transId" integer;
declare variable "azsId" integer;
declare variable "lastTerminalTransNo" integer;
declare variable "cardId" integer;
declare variable "orgId" integer;
declare variable "tankStateIdBegin" integer;
declare variable "tankStateIdEnd" integer;
declare variable "cardOwner" varchar(30);
declare variable "price" numeric(7,2);
declare variable "autoId" integer;
declare variable "autoName" varchar(30);
begin
/*
 if (:"DateBegin" > current_timestamp)
   then exception "dateInFuture";

 if (exists (select 1 from "CardTransaction" t  where t."TerminalId" = :"TerminalId" and t."DateBegin" > :"DateBegin"))
   then exception "terminalTransactionFailDate";
*/

 if ("DensityBegin" = 0)
   then "DensityBegin" = null;
 if ("DensityEnd" = 0)
   then "DensityEnd" = null;

 /*   */
 select "AzsId", t."LastTransNo"
    from "Terminal" t
      where "TerminalId" = :"TerminalId" into :"azsId", :"lastTerminalTransNo";
 if ("TerminalTransNo" <= "lastTerminalTransNo")
  then exception "terminalTransactionExists";

 select "CardId", "OrgId" from "Card" c where "CardNo" = :"CardNo" into :"cardId", :"orgId";
 if ("cardId" is null) then begin
  "cardId" = GEN_ID("GEN_Card_Id", 1);
  "orgId" = 0;
  insert into "Card" ("CardId", "CardNo", "Enabled", "OperId", "OrgId", "Expire")
  values (:"cardId", :"CardNo", 0, 0,0, '01.01.2000');
 end

 if ("OperId" = 0) then
   select "OperId" from "Card" where "CardId" = :"cardId" into :"OperId";
 if ("OperId" is null or "OperId" < 1 or "OperId" > 4)
  then "OperId" = 1;

 select "Price" from "FuelPriceByOrg" a where "FuelId" = :"FuelId" and "OrgId" = :"orgId" into :"price";
 if ("price" is null) then
     select "Price" from "Fuel" where "FuelId" = :"FuelId" into :"price";
 if ("CurRest" < 0)
   then "CurRest" = 0;
 if (exists (select 1 from "Tank" t where "TankId" = :"TankId" and "TerminalId" = :"TerminalId")) then begin
   execute procedure "TankRealState_U"(:"TankId", :"DateBegin", :"TankStatusBegin", :"LevelBegin", :"VolumeBegin", :"TemperatureBegin", :"DensityBegin", :"WaterLevelBegin", null, 1) returning_values (:"tankStateIdBegin");
   execute procedure "TankRealState_U"(:"TankId", :"DateEnd", :"TankStatusEnd", :"LevelEnd", :"VolumeEnd", :"TemperatureEnd", :"DensityEnd", :"WaterLevelEnd", null, 1) returning_values (:"tankStateIdEnd");
 end
 if ("PumpId" is not null) then
   execute procedure "Pump_setCounter"(:"PumpId", :"DateBegin", :"CounterBegin", 0);
 "transId" = GEN_ID("GEN_TransId", 1);
 insert into "CardTransaction" ("TransId", "CardId", "OrgId", "AzsId", "TerminalId",
    "TerminalTransNo", "PumpId", "FuelId", "TankId", "OperId", "DateBegin",
    "DateEnd", "CounterBegin", "CounterEnd", "TankStateIdBegin",
    "TankStateIdEnd", "Volume", "Price", "CurLimit", "CurRest")
                        values (:"transId", :"cardId", :"orgId", :"azsId", :"TerminalId",
    :"TerminalTransNo", :"PumpId", :"FuelId", :"TankId", :"OperId", :"DateBegin",
    :"DateEnd", :"CounterBegin", :"CounterEnd", :"tankStateIdBegin",
    :"tankStateIdEnd", :"Volume", :"price", :"CurLimit", :"CurRest");
 if ("PumpId" is not null) then
   execute procedure "Pump_setCounter"(:"PumpId", :"DateBegin", :"CounterEnd", :"Volume");
 /*  ,  */
 if ("OperId" = 1 or "OperId" = 2 or "OperId" = 3) then begin
   if (:"AutoType" = 1) then
       select "AutoId"  from "Auto" where "Pin" = :"Auto" into :"autoId";
   else if (:"AutoType" = 2) then begin
      select "Owner" from "Card" where "CardNo" = :"Auto" into :"autoName";
      select "AutoId"  from "Auto" where "Description" = :"autoName" into :"autoId";
      if ("autoId" is null) then begin
         "autoId" = GEN_ID("GEN_Id", 1);
         insert into "Auto" ("AutoId", "Pin",  "Number",  "Description") values (:"autoId", null, '#' ||  GEN_ID("GEN_AutoNumber", 1), :"autoName");
      end
   end

   select "Owner" from "Card" where "CardId" = :"cardId" into :"cardOwner";
   insert into "FuelSale" ("Id", "OrgId", "AzsId", "TankId", "CardTransId", "Date", "Client", "FuelId", "Volume", "Price", "AutoId")
                values (GEN_ID("GEN_FuelOper_Id", 1), :"orgId", :"azsId", :"TankId", :"transId", :"DateBegin", :"cardOwner", :"FuelId", :"Volume", :"price", :"autoId");
 end
 /*
 if ("OperId" = 2) then begin
   select "Owner" from "Card" where "CardId" = :"cardId" into :"cardOwner";
   insert into "FuelIncome" ("Id", "OrgId", "AzsId", "TankId", "CardTransId", "Date", "Supplier", "FuelId", "Volume")
                values (GEN_ID("GEN_FuelOper_Id", 1), :"orgId", 2, 12,  :"transId", :"DateBegin", '<>', :"fuelId", :"Volume");
 end
 */

 if ("OperId" = 3) then begin
   select "Owner" from "Card" where "CardId" = :"cardId" into :"cardOwner";
   insert into "FuelIncome" ("Id", "OrgId", "AzsId", "TankId", "CardTransId", "Date", "Supplier", "FuelId", "Volume")
                values (GEN_ID("GEN_FuelOper_Id", 1), :"orgId", :"azsId", :"TankId",  :"transId", :"DateBegin", '<>', :"FuelId", :"Volume");
 end

 /*  c  */
 update "Terminal"
   set "LastTransNo" = :"TerminalTransNo"
     where "TerminalId" = :"TerminalId";
end^


ALTER PROCEDURE "Terminal_SyncComplete" (
    "termId" INTEGER,
    "ok" INTEGER,
    "msg" VARCHAR(255))
AS
declare variable "date" timestamp;
begin
 "date" = current_timestamp;
 update "Terminal"
  set "SyncDate" = :"date", "SyncStatus" = :"msg"
   where "TerminalId" = :"termId";
 if ("ok" <> 0) then
 update "Terminal"
  set "SyncOkDate" = :"date"
   where "TerminalId" = :"termId";
end^


ALTER PROCEDURE "User_DEL" (
    "UserId" INTEGER)
AS
begin
  delete from "User"
  where ("UserId" = :"UserId");
end^


ALTER PROCEDURE "User_IU" (
    "UserId" INTEGER,
    "Active" SMALLINT,
    "Name" VARCHAR(20),
    "Psw" VARCHAR(20),
    "Permissions" INTEGER)
AS
begin
  if (exists(select "UserId" from "User" where ("UserId" = :"UserId"))) then
    update "User"
    set "Active" = :"Active",
        "Name" = :"Name",
        "Psw" = :"Psw",
        "Permissions" = :"Permissions"
    where ("UserId" = :"UserId");
  else
    insert into "User" (
        "UserId",
        "Active",
        "Name",
        "Psw",
        "Permissions")
    values (
        :"UserId",
        :"Active",
        :"Name",
        :"Psw",
        :"Permissions");
end^



SET TERM ; ^


/******************************************************************************/
/***                                 Roles                                  ***/
/******************************************************************************/

CREATE ROLE OPERATOR;


/******************************************************************************/
/***                              Descriptions                              ***/
/******************************************************************************/

UPDATE RDB$FIELDS
SET RDB$DESCRIPTION = '0 -  
1 - 
2 - 
3 - 
4 -  '
WHERE (RDB$FIELD_NAME = 'CardOperation');

UPDATE RDB$FIELDS
SET RDB$DESCRIPTION = '0 - Mifare
1 - iButton'
WHERE (RDB$FIELD_NAME = 'CardType');

UPDATE RDB$FIELDS
SET RDB$DESCRIPTION = '0 - 
1 - 
2 - 
3 - 
4 -  (  )
5 - '
WHERE (RDB$FIELD_NAME = 'LimitType');

UPDATE RDB$FIELDS
SET RDB$DESCRIPTION = '   , '
WHERE (RDB$FIELD_NAME = 'TankLevel');

UPDATE RDB$FIELDS
SET RDB$DESCRIPTION = '   , '
WHERE (RDB$FIELD_NAME = 'TankVolume');



/******************************************************************************/
/***                              Descriptions                              ***/
/******************************************************************************/

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ': '
WHERE (RDB$RELATION_NAME = 'Auto');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ': '
WHERE (RDB$RELATION_NAME = 'Azs');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ': '
WHERE (RDB$RELATION_NAME = 'Card');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':  '
WHERE (RDB$RELATION_NAME = 'CardLimitTypes');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':  '
WHERE (RDB$RELATION_NAME = 'CardOperationTypes');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':   '
WHERE (RDB$RELATION_NAME = 'CardTransaction');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':   '
WHERE (RDB$RELATION_NAME = 'FIB$ERROR_MESSAGES');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':  '
WHERE (RDB$RELATION_NAME = 'Fuel');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':  '
WHERE (RDB$RELATION_NAME = 'FuelIncome');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':     '
WHERE (RDB$RELATION_NAME = 'FuelPriceByOrg');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':  '
WHERE (RDB$RELATION_NAME = 'FuelSale');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':   '
WHERE (RDB$RELATION_NAME = 'FuelStorage');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':  GSM '
WHERE (RDB$RELATION_NAME = 'GsmModem');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ': '
WHERE (RDB$RELATION_NAME = 'Organization');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ': '
WHERE (RDB$RELATION_NAME = 'Pump');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ': '
WHERE (RDB$RELATION_NAME = 'Tank');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':    '
WHERE (RDB$RELATION_NAME = 'TankBookStateHistory');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':   '
WHERE (RDB$RELATION_NAME = 'TankCalibration');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':    '
WHERE (RDB$RELATION_NAME = 'TankRealStateHistory');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ':  '
WHERE (RDB$RELATION_NAME = 'TankState');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ': '
WHERE (RDB$RELATION_NAME = 'Terminal');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ': '
WHERE (RDB$RELATION_NAME = 'User');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = ': '
WHERE (RDB$RELATION_NAME = 'vars');



/******************************************************************************/
/***                          Fields descriptions                           ***/
/******************************************************************************/

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'Auto') AND (RDB$FIELD_NAME = 'AutoId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'PIN  '
WHERE (RDB$RELATION_NAME = 'Auto') AND (RDB$FIELD_NAME = 'Pin');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Auto') AND (RDB$FIELD_NAME = 'Number');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'Auto') AND (RDB$FIELD_NAME = 'Description');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'Azs') AND (RDB$FIELD_NAME = 'AzsId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'Azs') AND (RDB$FIELD_NAME = 'Name');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Azs') AND (RDB$FIELD_NAME = 'Owner');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'Card') AND (RDB$FIELD_NAME = 'CardId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Card') AND (RDB$FIELD_NAME = 'CardNo');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Card') AND (RDB$FIELD_NAME = 'Owner');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Card') AND (RDB$FIELD_NAME = 'Enabled');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' (. . CardOperationTypes)'
WHERE (RDB$RELATION_NAME = 'Card') AND (RDB$FIELD_NAME = 'OperId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'Card') AND (RDB$FIELD_NAME = 'LastUpdate');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID'
WHERE (RDB$RELATION_NAME = 'CardLimitTypes') AND (RDB$FIELD_NAME = 'LimitTypeId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'CardLimitTypes') AND (RDB$FIELD_NAME = 'Name');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' (1-, 0-)'
WHERE (RDB$RELATION_NAME = 'CardLimitTypes') AND (RDB$FIELD_NAME = 'Enabled');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID'
WHERE (RDB$RELATION_NAME = 'CardOperationTypes') AND (RDB$FIELD_NAME = 'OperId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'CardOperationTypes') AND (RDB$FIELD_NAME = 'Name');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' (1-, 0-)'
WHERE (RDB$RELATION_NAME = 'CardOperationTypes') AND (RDB$FIELD_NAME = 'Enabled');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'TransId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'CardId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  (. . CardLimitTypes)'
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'LimitType');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Azs)'
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'AzsId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Terminal)'
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'TerminalId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '   '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'TerminalTransNo');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . )'
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'PumpId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID   (. . Fuel )'
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'FuelId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Tank)'
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'TankId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID   (. . CardOperationTypes)'
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'OperId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'DateBegin');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'DateEnd');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'Date');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '    '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'CounterBegin');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '    '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'CounterEnd');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID      (. . TankState)'
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'TankStateIdBegin');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID      (. . TankState)'
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'TankStateIdEnd');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'Volume');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'Price');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'Money');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' , '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'CurLimit');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  , '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'CurRest');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'deleted');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'CardTransaction') AND (RDB$FIELD_NAME = 'LastUpdate');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'FuelIncome') AND (RDB$FIELD_NAME = 'Id');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Azs)'
WHERE (RDB$RELATION_NAME = 'FuelIncome') AND (RDB$FIELD_NAME = 'AzsId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Tank)'
WHERE (RDB$RELATION_NAME = 'FuelIncome') AND (RDB$FIELD_NAME = 'TankId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . CardTransaction).  null -    '
WHERE (RDB$RELATION_NAME = 'FuelIncome') AND (RDB$FIELD_NAME = 'CardTransId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'FuelIncome') AND (RDB$FIELD_NAME = 'Date');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'FuelIncome') AND (RDB$FIELD_NAME = 'Doc');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'FuelIncome') AND (RDB$FIELD_NAME = 'DocDate');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'FuelIncome') AND (RDB$FIELD_NAME = 'Supplier');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID   (. . Fuel )'
WHERE (RDB$RELATION_NAME = 'FuelIncome') AND (RDB$FIELD_NAME = 'FuelId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '   '
WHERE (RDB$RELATION_NAME = 'FuelIncome') AND (RDB$FIELD_NAME = 'Volume');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'FuelIncome') AND (RDB$FIELD_NAME = 'deleted');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'Id');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Azs)'
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'AzsId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Tank)'
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'TankId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . CardTransaction).  null -    '
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'CardTransId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'Date');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'Doc');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'DocDate');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'Client');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Auto)'
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'AutoId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID   (. . Fuel )'
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'FuelId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'Volume');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'FuelSale') AND (RDB$FIELD_NAME = 'deleted');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'GsmModem') AND (RDB$FIELD_NAME = 'TerminalId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '   '
WHERE (RDB$RELATION_NAME = 'GsmModem') AND (RDB$FIELD_NAME = 'TelNo');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'GsmModem') AND (RDB$FIELD_NAME = 'USSD_Balance');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'Pump') AND (RDB$FIELD_NAME = 'PumpId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Terminal)'
WHERE (RDB$RELATION_NAME = 'Pump') AND (RDB$FIELD_NAME = 'TerminalId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Pump') AND (RDB$FIELD_NAME = 'PumpNo');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'Pump') AND (RDB$FIELD_NAME = 'NozzleNo');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Tank)'
WHERE (RDB$RELATION_NAME = 'Pump') AND (RDB$FIELD_NAME = 'TankId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Pump') AND (RDB$FIELD_NAME = 'Counter');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'Tank') AND (RDB$FIELD_NAME = 'TankId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Tank') AND (RDB$FIELD_NAME = 'TankNo');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Azs)'
WHERE (RDB$RELATION_NAME = 'Tank') AND (RDB$FIELD_NAME = 'AzsId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Terminal)'
WHERE (RDB$RELATION_NAME = 'Tank') AND (RDB$FIELD_NAME = 'TerminalId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID   (. . Fuel)'
WHERE (RDB$RELATION_NAME = 'Tank') AND (RDB$FIELD_NAME = 'FuelId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Tank') AND (RDB$FIELD_NAME = 'TotalHeight');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Tank') AND (RDB$FIELD_NAME = 'TotalVolume');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'Tank') AND (RDB$FIELD_NAME = 'MinLevel');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID    '
WHERE (RDB$RELATION_NAME = 'Tank') AND (RDB$FIELD_NAME = 'BookStateId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID    '
WHERE (RDB$RELATION_NAME = 'Tank') AND (RDB$FIELD_NAME = 'RealStateId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID   (. . TankState)'
WHERE (RDB$RELATION_NAME = 'TankBookStateHistory') AND (RDB$FIELD_NAME = 'TankStateId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'TankBookStateHistory') AND (RDB$FIELD_NAME = 'Date');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Tank)'
WHERE (RDB$RELATION_NAME = 'TankBookStateHistory') AND (RDB$FIELD_NAME = 'TankId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID   (. . Fuel)'
WHERE (RDB$RELATION_NAME = 'TankBookStateHistory') AND (RDB$FIELD_NAME = 'FuelId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Tank)'
WHERE (RDB$RELATION_NAME = 'TankCalibration') AND (RDB$FIELD_NAME = 'TankId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ', '
WHERE (RDB$RELATION_NAME = 'TankCalibration') AND (RDB$FIELD_NAME = 'Level');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ', '
WHERE (RDB$RELATION_NAME = 'TankCalibration') AND (RDB$FIELD_NAME = 'Volume');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID   (. . TankState)'
WHERE (RDB$RELATION_NAME = 'TankRealStateHistory') AND (RDB$FIELD_NAME = 'TankStateId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'TankRealStateHistory') AND (RDB$FIELD_NAME = 'Date');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Tank)'
WHERE (RDB$RELATION_NAME = 'TankRealStateHistory') AND (RDB$FIELD_NAME = 'TankId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID   (. . Fuel)'
WHERE (RDB$RELATION_NAME = 'TankRealStateHistory') AND (RDB$FIELD_NAME = 'FuelId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  (1-, 0-)'
WHERE (RDB$RELATION_NAME = 'TankRealStateHistory') AND (RDB$FIELD_NAME = 'Locked');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID'
WHERE (RDB$RELATION_NAME = 'TankState') AND (RDB$FIELD_NAME = 'TankStateId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' (0 - ,  -  )'
WHERE (RDB$RELATION_NAME = 'TankState') AND (RDB$FIELD_NAME = 'Status');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' , '
WHERE (RDB$RELATION_NAME = 'TankState') AND (RDB$FIELD_NAME = 'Level');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' , '
WHERE (RDB$RELATION_NAME = 'TankState') AND (RDB$FIELD_NAME = 'Volume');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ', *C'
WHERE (RDB$RELATION_NAME = 'TankState') AND (RDB$FIELD_NAME = 'Temperature');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ', / .'
WHERE (RDB$RELATION_NAME = 'TankState') AND (RDB$FIELD_NAME = 'Density');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' , '
WHERE (RDB$RELATION_NAME = 'TankState') AND (RDB$FIELD_NAME = 'WaterLevel');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' , '
WHERE (RDB$RELATION_NAME = 'TankState') AND (RDB$FIELD_NAME = 'WaterVolume');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'Terminal') AND (RDB$FIELD_NAME = 'TerminalId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID  (. . Azs)'
WHERE (RDB$RELATION_NAME = 'Terminal') AND (RDB$FIELD_NAME = 'AzsId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Terminal') AND (RDB$FIELD_NAME = 'SerialNo');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'Terminal') AND (RDB$FIELD_NAME = 'Name');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'Terminal') AND (RDB$FIELD_NAME = 'NetAdr');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'Terminal') AND (RDB$FIELD_NAME = 'Flags');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '    '
WHERE (RDB$RELATION_NAME = 'Terminal') AND (RDB$FIELD_NAME = 'LastTransNo');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'Terminal') AND (RDB$FIELD_NAME = 'SyncDate');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  '
WHERE (RDB$RELATION_NAME = 'Terminal') AND (RDB$FIELD_NAME = 'SyncStatus');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '   '
WHERE (RDB$RELATION_NAME = 'Terminal') AND (RDB$FIELD_NAME = 'SyncOkDate');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'ID '
WHERE (RDB$RELATION_NAME = 'User') AND (RDB$FIELD_NAME = 'UserId');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = '  (1-,0-)'
WHERE (RDB$RELATION_NAME = 'User') AND (RDB$FIELD_NAME = 'Active');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'User') AND (RDB$FIELD_NAME = 'Name');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'User') AND (RDB$FIELD_NAME = 'Psw');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'User') AND (RDB$FIELD_NAME = 'Permissions');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ' '
WHERE (RDB$RELATION_NAME = 'vars') AND (RDB$FIELD_NAME = 'Name');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = ''
WHERE (RDB$RELATION_NAME = 'vars') AND (RDB$FIELD_NAME = 'Value');

COMMIT WORK;



/******************************************************************************/
/***                               Privileges                               ***/
/******************************************************************************/


/* Privileges of roles */
GRANT EXECUTE ON PROCEDURE "TankStateHistoryByDate" TO OPERATOR;

/* Privileges of procedures */
GRANT SELECT, DELETE ON "Auto" TO PROCEDURE "Auto_DEL";
GRANT SELECT, INSERT, UPDATE ON "Auto" TO PROCEDURE "Auto_IU";
GRANT SELECT, DELETE ON "Azs" TO PROCEDURE "Azs_DEL";
GRANT SELECT, DELETE ON "Pump" TO PROCEDURE "Azs_DEL";
GRANT SELECT, DELETE ON "Tank" TO PROCEDURE "Azs_DEL";
GRANT SELECT, DELETE ON "Terminal" TO PROCEDURE "Azs_DEL";
GRANT SELECT, INSERT, UPDATE ON "Azs" TO PROCEDURE "Azs_IU";
GRANT SELECT, DELETE ON "FuelIncome" TO PROCEDURE "FuelIncome_DEL";
GRANT SELECT, INSERT, UPDATE ON "FuelIncome" TO PROCEDURE "FuelIncome_IU";
GRANT SELECT ON "Tank" TO PROCEDURE "FuelIncome_IU";
GRANT SELECT, DELETE ON "FuelSale" TO PROCEDURE "FuelSale_DEL";
GRANT SELECT, INSERT, UPDATE ON "FuelSale" TO PROCEDURE "FuelSale_IU";
GRANT SELECT, INSERT, UPDATE ON "FuelStorage" TO PROCEDURE "FuelStorage_U";
GRANT SELECT, DELETE ON "Fuel" TO PROCEDURE "Fuel_DEL";
GRANT SELECT, INSERT, UPDATE ON "Fuel" TO PROCEDURE "Fuel_IU";
GRANT SELECT, DELETE ON "Pump" TO PROCEDURE "Pump_DEL";
GRANT SELECT ON "CardTransaction" TO PROCEDURE "Pump_IU";
GRANT SELECT, INSERT, UPDATE ON "Pump" TO PROCEDURE "Pump_IU";
GRANT SELECT ON "Tank" TO PROCEDURE "Pump_IU";
GRANT SELECT ON "Terminal" TO PROCEDURE "Pump_IU";
GRANT INSERT ON "CardTransaction" TO PROCEDURE "Pump_setCounter";
GRANT SELECT, UPDATE ON "Pump" TO PROCEDURE "Pump_setCounter";
GRANT SELECT ON "Tank" TO PROCEDURE "Pump_setCounter";
GRANT SELECT ON "Terminal" TO PROCEDURE "Pump_setCounter";
GRANT SELECT, UPDATE ON "Tank" TO PROCEDURE "TankBookState_U";
GRANT SELECT, INSERT ON "TankBookStateHistory" TO PROCEDURE "TankBookState_U";
GRANT SELECT, UPDATE ON "TankState" TO PROCEDURE "TankBookState_U";
GRANT EXECUTE ON PROCEDURE "TankState_COPY" TO PROCEDURE "TankBookState_U";
GRANT EXECUTE ON PROCEDURE "TankState_INS" TO PROCEDURE "TankBookState_U";
GRANT EXECUTE ON PROCEDURE "Tank_l2mm" TO PROCEDURE "TankBookState_U";
GRANT SELECT, DELETE ON "TankCalibration" TO PROCEDURE "TankCalibration_DEL";
GRANT INSERT ON "TankCalibration" TO PROCEDURE "TankCalibration_INS";
GRANT SELECT, UPDATE ON "Tank" TO PROCEDURE "TankRealState_INS";
GRANT SELECT, INSERT ON "TankRealStateHistory" TO PROCEDURE "TankRealState_INS";
GRANT EXECUTE ON PROCEDURE "TankState_INS" TO PROCEDURE "TankRealState_INS";
GRANT SELECT, UPDATE ON "Tank" TO PROCEDURE "TankRealState_U";
GRANT SELECT, INSERT, UPDATE ON "TankRealStateHistory" TO PROCEDURE "TankRealState_U";
GRANT SELECT, UPDATE ON "TankState" TO PROCEDURE "TankRealState_U";
GRANT EXECUTE ON PROCEDURE "TankState_INS" TO PROCEDURE "TankRealState_U";
GRANT EXECUTE ON PROCEDURE "Tank_mm2l" TO PROCEDURE "TankRealState_U";
GRANT SELECT ON "Tank" TO PROCEDURE "TankStateHistoryByDate";
GRANT SELECT ON "TankBookStateHistory" TO PROCEDURE "TankStateHistoryByDate";
GRANT SELECT ON "TankRealStateHistory" TO PROCEDURE "TankStateHistoryByDate";
GRANT SELECT, INSERT ON "TankState" TO PROCEDURE "TankState_COPY";
GRANT INSERT ON "TankState" TO PROCEDURE "TankState_INS";
GRANT EXECUTE ON PROCEDURE "Tank_mm2l" TO PROCEDURE "TankState_INS";
GRANT SELECT, UPDATE, DELETE ON "Tank" TO PROCEDURE "Tank_DEL";
GRANT SELECT, DELETE ON "TankBookStateHistory" TO PROCEDURE "Tank_DEL";
GRANT SELECT, DELETE ON "TankRealStateHistory" TO PROCEDURE "Tank_DEL";
GRANT SELECT, DELETE ON "TankState" TO PROCEDURE "Tank_DEL";
GRANT SELECT ON "Pump" TO PROCEDURE "Tank_IU";
GRANT SELECT, INSERT, UPDATE ON "Tank" TO PROCEDURE "Tank_IU";
GRANT INSERT ON "TankBookStateHistory" TO PROCEDURE "Tank_IU";
GRANT INSERT ON "TankRealStateHistory" TO PROCEDURE "Tank_IU";
GRANT SELECT ON "Terminal" TO PROCEDURE "Tank_IU";
GRANT EXECUTE ON PROCEDURE "TankState_INS" TO PROCEDURE "Tank_IU";
GRANT SELECT ON "Tank" TO PROCEDURE "Tank_l2mm";
GRANT SELECT ON "TankCalibration" TO PROCEDURE "Tank_l2mm";
GRANT SELECT ON "TankCalibration" TO PROCEDURE "Tank_mm2l";
GRANT SELECT ON "Tank" TO PROCEDURE "Terminal_Add_TankState";
GRANT EXECUTE ON PROCEDURE "TankRealState_U" TO PROCEDURE "Terminal_Add_TankState";
GRANT SELECT ON "Auto" TO PROCEDURE "Terminal_Add_Transaction";
GRANT SELECT, INSERT ON "Card" TO PROCEDURE "Terminal_Add_Transaction";
GRANT INSERT ON "CardTransaction" TO PROCEDURE "Terminal_Add_Transaction";
GRANT SELECT ON "Fuel" TO PROCEDURE "Terminal_Add_Transaction";
GRANT INSERT ON "FuelIncome" TO PROCEDURE "Terminal_Add_Transaction";
GRANT INSERT ON "FuelSale" TO PROCEDURE "Terminal_Add_Transaction";
GRANT SELECT ON "Pump" TO PROCEDURE "Terminal_Add_Transaction";
GRANT SELECT ON "Tank" TO PROCEDURE "Terminal_Add_Transaction";
GRANT SELECT, UPDATE ON "Terminal" TO PROCEDURE "Terminal_Add_Transaction";
GRANT EXECUTE ON PROCEDURE "Pump_setCounter" TO PROCEDURE "Terminal_Add_Transaction";
GRANT EXECUTE ON PROCEDURE "TankRealState_U" TO PROCEDURE "Terminal_Add_Transaction";
GRANT SELECT, DELETE ON "User" TO PROCEDURE "User_DEL";
GRANT SELECT, INSERT, UPDATE ON "User" TO PROCEDURE "User_IU";
GRANT SELECT, UPDATE, DELETE ON "CardTransaction" TO PROCEDURE "db_clear";
GRANT SELECT, UPDATE, DELETE ON "FuelIncome" TO PROCEDURE "db_clear";
GRANT SELECT, UPDATE, DELETE ON "FuelSale" TO PROCEDURE "db_clear";
GRANT SELECT ON "Tank" TO PROCEDURE "db_clear";
GRANT SELECT, DELETE ON "TankBookStateHistory" TO PROCEDURE "db_clear";
GRANT SELECT, DELETE ON "TankRealStateHistory" TO PROCEDURE "db_clear";
GRANT SELECT, DELETE ON "TankState" TO PROCEDURE "db_clear";
GRANT SELECT ON "FuelIncome" TO PROCEDURE "db_make_book_state";
GRANT SELECT ON "FuelSale" TO PROCEDURE "db_make_book_state";
GRANT SELECT, UPDATE ON "Tank" TO PROCEDURE "db_make_book_state";
GRANT SELECT, DELETE ON "TankBookStateHistory" TO PROCEDURE "db_make_book_state";
GRANT SELECT, DELETE ON "TankState" TO PROCEDURE "db_make_book_state";
GRANT EXECUTE ON PROCEDURE "TankBookState_U" TO PROCEDURE "db_make_book_state";
